#!/bin/sh
NAS_ARCH=armhf
NAS_MODEL=nas5xx
BSPDEBVER=5.21

BSP_BUILD_ROOT=`pwd`/linux-bsp-${NAS_MODEL}

mkdir -p "${BSP_BUILD_ROOT}"


BSPDEBNAM=linux-bsp-${NAS_MODEL}
BSPDEBDIR=${BSP_BUILD_ROOT}/${BSPDEBNAM}_${BSPDEBVER}_${NAS_ARCH}

cd /

sudo tar czvf ${BSP_BUILD_ROOT}/linux-bsp-${NAS_MODEL}-flat.tar.gz \
  bin/storage_asm_mntfw_swap.sh \
  etc/zy-profile \
  usr/local/bin/select-fan-speed.sh \
  usr/local/bin/get-* \
  usr/local/bin/zy-fw-get-info \
  usr/local/bin/zy-init-get \
  usr/local/bin/zy-hw-init \
  usr/local/bin/zy-led-test \
  usr/local/bin/zy-nand-get \
  usr/local/bin/zy-nand-mount \
  usr/local/bin/zy-sysdisk-mount \
  usr/local/bin/zy-*-write \
  usr/local/etc/zy-nand-profile

cd - > /dev/null

mkdir -p "${BSPDEBDIR}"

cd "${BSPDEBDIR}"

fakeroot tar xzf ${BSP_BUILD_ROOT}/linux-bsp-${NAS_MODEL}-flat.tar.gz

cd - > /dev/null

fakeroot mkdir -p ${BSPDEBDIR}
fakeroot mkdir    ${BSPDEBDIR}/DEBIAN

#sudo chmod 755 ${BSPDEBDIR}/DEBIAN

echo "/etc/zy-profile" > ${BSPDEBDIR}/DEBIAN/conffiles
echo "/usr/local/etc/zy-nand-profile" >> ${BSPDEBDIR}/DEBIAN/conffiles

cat <<EOFDRUBSPC | sudo tee ${BSPDEBDIR}/DEBIAN/control > /dev/null
Package: ${BSPDEBNAM}
Architecture: ${NAS_ARCH}
Maintainer: SCP
Depends: i2c-tools, mtd-utils
Priority: optional
Version: ${BSPDEBVER}
Description: ${NAS_MODEL} BSP Core
EOFDRUBSPC

find ${BSPDEBDIR} -type d -exec chmod g-s {} \;

cd "${BSP_BUILD_ROOT}"
fakeroot dpkg-deb --build ${BSPDEBDIR}

cd - > /dev/null

cp -p ${BSP_BUILD_ROOT}/${BSPDEBNAM}_${BSPDEBVER}_${NAS_ARCH}.deb .


zip ${BSP_BUILD_ROOT}/${BSPDEBNAM}-${BSPDEBVER}-${NAS_ARCH}.zip install-bsp.sh ${BSPDEBNAM}_${BSPDEBVER}_${NAS_ARCH}.deb



BSPDEBNAM=linux-bsp-${NAS_MODEL}-init
BSPDEBDIR=${BSP_BUILD_ROOT}/${BSPDEBNAM}_${BSPDEBVER}_${NAS_ARCH}

cd /

sudo tar czvf ${BSP_BUILD_ROOT}/${BSPDEBNAM}-flat.tar.gz \
  debinit.sh \
  etc/preinit \
  lib/systemd/system/zy-ready.service \
  lib/systemd/system/zy-stop.service \
  usr/local/bin/deb*.sh \
  usr/local/bin/dru-*.sh \
  usr/local/bin/mount-md.sh \
  usr/local/bin/start-md.sh \
  usr/local/bin/zy-ready \
  usr/local/bin/zy-stop

cd - > /dev/null

mkdir -p "${BSPDEBDIR}"

cd "${BSPDEBDIR}"

fakeroot tar xzf ${BSP_BUILD_ROOT}/${BSPDEBNAM}-flat.tar.gz

cd - > /dev/null

fakeroot mkdir -p ${BSPDEBDIR}
fakeroot mkdir    ${BSPDEBDIR}/DEBIAN

#sudo chmod 755 ${BSPDEBDIR}/DEBIAN

#echo "/etc/zy-profile" > ${BSPDEBDIR}/DEBIAN/conffiles
#echo "/usr/local/etc/zy-nand-profile" >> ${BSPDEBDIR}/DEBIAN/conffiles

cat <<EOFDRUBSPC | sudo tee ${BSPDEBDIR}/DEBIAN/control > /dev/null
Package: ${BSPDEBNAM}
Architecture: ${NAS_ARCH}
Maintainer: SCP
Depends: i2c-tools, mtd-utils
Priority: optional
Version: ${BSPDEBVER}
Description: ${NAS_MODEL} BSP init scripts
EOFDRUBSPC

cat <<\EOFDRUBSPP | sudo tee ${BSPDEBDIR}/DEBIAN/postinst > /dev/null
#!/bin/sh
systemctl enable zy-ready
systemctl enable zy-stop

if [ ! -e /bin/nice      ]; then ln -s `which nice`    /bin/nice      ; else true ; fi
if [ ! -e /sbin/watchdog ]; then ln -s `which busybox` /sbin/watchdog ; else true ; fi
if [ ! -e /sbin/flashcp        ]; then ln -s `which flashcp`        /sbin/flashcp        ; else true ; fi
if [ ! -e /sbin/flash_erase    ]; then ln -s `which flash_erase`    /sbin/flash_erase    ; else true ; fi
if [ ! -e /sbin/flash_eraseall ]; then ln -s `which flash_eraseall` /sbin/flash_eraseall ; else true ; fi
if [ ! -e /sbin/nanddump       ]; then ln -s `which nanddump`       /sbin/nanddump       ; else true ; fi
if [ ! -e /sbin/nandwrite      ]; then ln -s `which nandwrite`      /sbin/nandwrite      ; else true ; fi
if [ ! -e /sbin/i2cget ]; then ln -s `which i2cget` /sbin/i2cget ; else true ; fi
if [ ! -e /sbin/i2cset ]; then ln -s `which i2cset` /sbin/i2cset ; else true ; fi
EOFDRUBSPP

sudo chmod ugo+rx ${BSPDEBDIR}/DEBIAN/postinst

find ${BSPDEBDIR} -type d -exec chmod g-s {} \;

cd "${BSP_BUILD_ROOT}"
fakeroot dpkg-deb --build ${BSPDEBDIR}

cd - > /dev/null

#cp -p ${BSP_BUILD_ROOT}/${BSPDEBNAM}_${BSPDEBVER}_${NAS_ARCH}.deb .


BSPDEBNAM=linux-bsp-${NAS_MODEL}-bin
BSPDEBDIR=${BSP_BUILD_ROOT}/${BSPDEBNAM}_${BSPDEBVER}_${NAS_ARCH}

cd /

sudo tar czvf ${BSP_BUILD_ROOT}/${BSPDEBNAM}-flat.tar.gz \
  firmware/sbin/bareboxenv \
  firmware/sbin/info_printenv \
  firmware/sbin/info_setenv \
  firmware/sbin/mmiotool \
  firmware/sbin/mrd_mac \
  firmware/sbin/mrd_model \
  sbin/buzzerc \
  sbin/mmiotool \
  sbin/rtcAccess \
  sbin/getLED \
  sbin/setLED \
  sbin/get_mac_mcu.sh \
  sbin/write_mac_mcu.sh

cd - > /dev/null

mkdir -p "${BSPDEBDIR}"

cd "${BSPDEBDIR}"

fakeroot tar xzf ${BSP_BUILD_ROOT}/${BSPDEBNAM}-flat.tar.gz

cd - > /dev/null

fakeroot mkdir -p ${BSPDEBDIR}
fakeroot mkdir    ${BSPDEBDIR}/DEBIAN

#sudo chmod 755 ${BSPDEBDIR}/DEBIAN

#echo "/etc/zy-profile" > ${BSPDEBDIR}/DEBIAN/conffiles
#echo "/usr/local/etc/zy-nand-profile" >> ${BSPDEBDIR}/DEBIAN/conffiles

cat <<EOFDRUBSPC | sudo tee ${BSPDEBDIR}/DEBIAN/control > /dev/null
Package: ${BSPDEBNAM}
Architecture: ${NAS_ARCH}
Maintainer: SCP
Depends: i2c-tools, mtd-utils
Priority: optional
Version: ${BSPDEBVER}
Description: ${NAS_MODEL} BSP binaries
EOFDRUBSPC

find ${BSPDEBDIR} -type d -exec chmod g-s {} \;

cd "${BSP_BUILD_ROOT}"
fakeroot dpkg-deb --build ${BSPDEBDIR}

cd - > /dev/null

#cp -p ${BSP_BUILD_ROOT}/${BSPDEBNAM}_${BSPDEBVER}_${NAS_ARCH}.deb .

