#!/bin/sh

NAS_ARCH=armhf
NAS_VENDOR=Zyxel
NAS_MODEL=nas5xx
NAS_MODEL_2=nas520
NAS_NAME=`echo "${NAS_MODEL}" | tr a-z A-Z`
NAS_ABINAME=3.2.0-4

DEB_VENDOR="ARM Ltd."
DEB_MODEL=vexpress
DEB_NAME="Versatile Express"
DEB_ABINAME=3.2.0-4
lldebva=46

NAS_KBUILD=`echo ${NAS_ABINAME} | cut -d "." -f 1-2`
NAS_KERNEL_VER=${NAS_ABINAME}-${NAS_MODEL}
NAS_KERNEL_DEB=linux-image-${NAS_ABINAME}-${NAS_MODEL}_1_none.deb


cd linux

if [ -e arch/arm/configs/sequoia_defconfig ]; then
  NAS_MODEL=mycloud
  NAS_MODEL_2=${NAS_MODEL}

  axcfg=arch/arm/configs/sequoia_defconfig

elif [ -e arch/arm/configs/alpine_defconfig ]; then
  NAS_MODEL=ds414j
  NAS_MODEL_2=ds214j

elif [ -e include/qnap ]; then
  NAS_MODEL=tsx31
  NAS_MODEL_2=tsx31

elif [ -e arch/arm/configs/gfrg200_defconfig ]; then
  NAS_MODEL=gfrg200
  NAS_MODEL_2=gfsc100
fi

if [ -e arch/arm/mach-kirkwood/nsa325-setup.c ]; then
  NAS_ARCH=armel
  NAS_MODEL=nsa325
  NAS_MODEL_2=nsa320
fi

NAS_VENDOR_SHORT=${NAS_VENDOR}
NAS_NAME=`echo "${NAS_MODEL}" | tr a-z A-Z`
NAS_NAME_2=`echo "${NAS_MODEL_2}" | tr a-z A-Z`

if [ -e arch/arm/configs/sequoia_defconfig ]; then
  NAS_VENDOR="Western Digital"
  NAS_VENDOR_SHORT=WD
  NAS_NAME="My Cloud"
  NAS_NAME_2=${NAS_NAME}

elif [ -e arch/arm/configs/alpine_defconfig ]; then
  NAS_VENDOR="Synology"
  NAS_VENDOR_SHORT=${NAS_VENDOR}
  NAS_NAME=`echo "${NAS_MODEL:0:5}" | tr a-z A-Z`${NAS_MODEL:5}
  NAS_NAME_2=`echo "${NAS_MODEL_2:0:5}" | tr a-z A-Z`${NAS_MODEL_2:5}

elif [ -e include/qnap ]; then
  NAS_VENDOR="Qnap"
  NAS_VENDOR_SHORT=${NAS_VENDOR}
  NAS_NAME=`echo "${NAS_MODEL:0:2}" | tr a-z A-Z`-${NAS_MODEL:2}
  NAS_NAME_2=`echo "${NAS_MODEL_2:0:2}" | tr a-z A-Z`-${NAS_MODEL_2:2}

elif [ -e arch/arm/configs/gfrg200_defconfig ]; then
  NAS_VENDOR="Google Fiber"
  NAS_VENDOR_SHORT="Google"
fi

NAS_NAME_SHORT=${NAS_NAME}
NAS_NAME_SHORT_2=${NAS_NAME_2}

if [ "${NAS_MODEL}" = "nas5xx" ]; then
  NAS_NAME="NAS520/NAS540/NAS542"
fi

cd ..


#echo linux-image
for f in `ls linux-image-*_*_*.deb 2>/dev/null`; do
    NAS_KERNEL_DEB=$f
    #echo found a ${NAS_KERNEL_DEB}
done

#echo linux-image-${NAS_KBUILD}
for f in `ls linux-image-${NAS_KBUILD}*_*_*.deb 2>/dev/null`; do
    NAS_KERNEL_DEB=$f
    #echo found b ${NAS_KERNEL_DEB}
done

#echo linux-image-${NAS_ABINAME}-${NAS_MODEL}
for f in `ls linux-image-${NAS_ABINAME}-${NAS_MODEL}_*_*.deb 2>/dev/null`; do
    NAS_KERNEL_DEB=$f
    #echo found c ${NAS_KERNEL_DEB}
done

if [ -e ${NAS_KERNEL_DEB} ]; then
    f=${NAS_KERNEL_DEB}
    karc=`echo $f | cut -d "_" -f 3 | cut -d "." -f 1`
    kver=`echo $f | cut -d "_" -f 1 | cut -d - -f 3-`
    kmmb=`echo $kver | cut -d "-" -f 1-2`
    kmm=`echo $kmmb | cut -d "." -f 1-2`
    if [ "x${kver}" != "x${karc}" ]; then
      #echo $kver
      NAS_ARCH=$karc
      NAS_KERNEL_VER=$kver
    fi
fi

mkdir -p archives
cd archives
wget -N http://http.debian.net/debian/pool/main/l/linux-latest/linux-latest_${lldebva}.tar.gz && \
wget -N http://http.debian.net/debian/pool/main/l/linux-latest/linux-latest_${lldebva}.dsc
cd ..

if [ ! -e linux-latest-${NAS_MODEL} ]; then
  tar xzvf archives/linux-latest_${lldebva}.tar.gz
  mv linux-latest linux-latest-${NAS_MODEL}
fi

if [ -e linux-latest-${NAS_MODEL} ]; then
  cd linux-latest-${NAS_MODEL}

  sed -i s/'linux-headers-'${DEB_MODEL}/'linux-headers-'${NAS_ARCH}/g debian/control
  sed -i s/'linux-headers-'${DEB_ABINAME}-${DEB_MODEL}/'linux-headers-'${NAS_KERNEL_VER}/g debian/control
  sed -i s/'linux-image-'${DEB_MODEL}/'linux-image-'${NAS_ARCH}/g debian/control

  sed -i s/'linux-image-'${DEB_ABINAME}-${DEB_MODEL}/'linux-image-'${NAS_KERNEL_VER}/g debian/control
  sed -i s/'linux-latest-modules-'${DEB_ABINAME}-${DEB_MODEL}/'linux-latest-modules-'${NAS_KERNEL_VER}/g debian/control

  sed -i "s/${DEB_VENDOR}/${NAS_VENDOR_SHORT}/g" debian/control
  sed -i "s/${DEB_NAME}/${NAS_NAME_SHORT}/g" debian/control

  sed -i s/'linux-headers-'${DEB_MODEL}/'linux-headers-'${NAS_ARCH}/g debian/rules*
  sed -i s/'linux-image-'${DEB_MODEL}/'linux-image-'${NAS_ARCH}/g debian/rules*
  sed -i s/'_'${NAS_ARCH}'_none_'${DEB_MODEL}/'_'${NAS_ARCH}'_none_'${NAS_ARCH}/g debian/rules*

  sed -i "s/FLAVOUR='"${DEB_MODEL}"'/FLAVOUR='"${NAS_MODEL}"'/g" debian/rules*
  sed -i "s/LOCALVERSION='-"${DEB_MODEL}"'/LOCALVERSION='-"${NAS_MODEL}"'/g" debian/rules*

  fakeroot make -f debian/rules debian/control debian/rules.gen
  fakeroot make -j4 -f debian/rules.gen binary-arch_${NAS_ARCH}_none_${NAS_ARCH}_real

  cd ..
fi

