#!/bin/sh

. ./tools-env.sh

export KBUILD_DEBARCH=armhf

export KDEB_PKGVERSION="${ltdebva}"
export KZIP_PKGVERSION="${KDEB_PKGVERSION}"

export CC=${ltdebcc}
export CXX=${ltdebcc/gcc/g++}

mkdir -p archives
cd archives

wget -N ${ltdebua}/linux-tools_${ltdebka}.orig.tar.gz && \
wget -N ${ltdebua}/linux-tools_${ltdebva}.debian.tar.gz && \
wget -N ${ltdebua}/linux-tools_${ltdebva}.dsc

cd ..

if [ ! -e linux-tools-${ltdebka} ]; then
  cp -p archives/linux-tools_${ltdebka}* .
  tar xzf archives/linux-tools_${ltdebka}.orig.tar.gz 

  cd linux-tools-${ltdebka}/
  tar xzf ../archives/linux-tools_${ltdebva}.debian.tar.gz 

  sed -i s/'CC = gcc'/'CC = '${CC}/g    debian/build/Makefile.inc
  sed -i s/'CXX = g++'/'CXX = '${CXX}/g debian/build/Makefile.inc

  cp -p ../tools*.patch debian/patches/
  echo "tools_perf_builtin-sched_add_sys_resource_h.patch" >> debian/patches/series

  debuild -e CC -e CXX -us -uc

  cd ..
fi

echo linux-tools-${KZIP_PKGVERSION}-${KBUILD_DEBARCH}.zip
zip linux-tools-${KZIP_PKGVERSION}-${KBUILD_DEBARCH}.zip install-kbuild.sh install-tools.sh linux-*_*${KDEB_PKGVERSION}_*.deb *usbip*_*${KDEB_PKGVERSION}_*.deb

