#!/bin/sh
. ./combine-env.sh

NAS_ARCH=armhf
NAS_VENDOR=Zyxel
NAS_MODEL=nas5xx
NAS_MODEL_2=nas520

lxcfgfilter=false
lxcfgmidi=true
lxcfgfull=false
lxcfgextra=false
lxcfgdebug=false


change_lxcfg() {
  if [ "x$2" = "x-" ]; then
    sed -i 's|'"$1"'||g' $3
  elif [ "x$2" = "xn" ]; then
    if grep -E $1'=.*' $3 > /dev/null ; then
      sed -i 's|'$1'=.*|# '$1' is not set|g' $3
    elif ! grep '# '$1' is not set' $3 > /dev/null ; then
      echo '# '$1' is not set' >> $3
    fi
  else
    if grep $1'='$2 $3 > /dev/null ; then
      true
    elif grep -E $1'=.*' $3 > /dev/null ; then
      sed -i 's|'$1'=.*|'$1'='$2'|g' $3
    elif grep '# '$1' is not set' $3 > /dev/null ; then
      sed -i 's|# '$1' is not set|'$1'='$2'|g' $3
    else
      echo $1'='$2 >> $3
    fi
  fi
}

extra_lxcfg() {
  excfg=$1
  sref=../combine-config.sh
  cref=${lxcfg}

  #if [ ! -e base-config ]; then
  #  cp -p config base-config
  #fi

  if [ $cref != base-config ]; then
    #echo "Patching config ${cref}..."
    if [ ! -e ref-config ]; then
      cp -p $cref ref-config
    fi
  fi

  aref=ref-config
  if [ ! -e ref-config ]; then
    cp -p $cref tmp-config
    aref=tmp-config
  fi

  echo ""
  echo "Merge ${excfg}..."

  cat ${excfg} | grep -E '^CONFIG_|^# CONFIG_' | while read d ; do
    n=`echo ${d} | sed s/'^# CONFIG_'/'CONFIG_'/g | sed s/' is not set'/'=n'/g | cut -d '=' -f 1`
    v=`echo ${d} | sed s/'^# CONFIG_'/'CONFIG_'/g | sed s/' is not set'/'=n'/g | cut -d '=' -f 2`
 
    if ! grep -E '^'${n}'=.*' ${aref} > /dev/null ; then
      if grep -E 'change_lxcfg '${n}' .*' ${sref} > /dev/null ; then
        echo "# skip ${n} ${v} (may be set later)"
      elif grep -E 'change_lxcfg '\'${n}\'' .*' ${sref} > /dev/null ; then
        echo "# skip ${n} ${v} (may be set later)"
      elif [ ${v} = n ]; then
        if ! grep -E '^# '${n}' .*' ${aref} > /dev/null ; then
          #change_lxcfg ${n} ${v} ${lxcfg}
          change_lxcfg ${n} ${v} ${cref}
        elif ! grep -E '^# '${n}' .*' ${cref} > /dev/null ; then
          echo "# skip ${n} ${v} (is unset in ${aref})"
        fi
      else
        #change_lxcfg ${n} ${v} ${lxcfg}
        change_lxcfg ${n} ${v} ${cref}
      fi

    elif [ "x${v}" = "xn" ]; then
      echo "# skip ${n} ${v} (is set in ${aref})"
    fi
  done
}

allphyset=y
onephyyes=n
namx=CONFIG_NO_PHY
valx=n

getphycfg() {
  namx=$1
  valx=n
  if grep -E '^'${namx}'=' ${lxcfg} ; then
    valx=`grep -E '^'${namx}'=' ${lxcfg} | cut -d '=' -f 2`
    if [ $valx = y ]; then
      if [ $onephyyes = y ]; then
        onephyyes=n
      else
        onephyyes=y
      fi
     fi
  else
    allphyset=n
  fi
}

if [ ! -e config ]; then
  echo "Downloading config linux-${lxsocka}..."
  wget -N ${lxsocua}/config
fi


cd linux/

axcfg=../config

if [ -e arch/arm/configs/sequoia_defconfig ]; then
  NAS_MODEL=mycloud
  NAS_MODEL_2=${NAS_MODEL}

  axcfg=arch/arm/configs/sequoia_defconfig

elif [ -e arch/arm/configs/alpine_defconfig ]; then
  NAS_MODEL=ds414j
  NAS_MODEL_2=ds214j

elif [ -e include/qnap ]; then
  NAS_MODEL=tsx31
  NAS_MODEL_2=tsx31

elif [ -e arch/arm/configs/gfrg200_defconfig ]; then
  NAS_MODEL=gfrg200
  NAS_MODEL_2=gfsc100
fi

if [ -e arch/arm/mach-kirkwood/nsa325-setup.c ]; then
  NAS_ARCH=armel
  NAS_MODEL=nsa325
  NAS_MODEL_2=nsa320
fi

NAS_VENDOR_SHORT=${NAS_VENDOR}
NAS_NAME=`echo "${NAS_MODEL}" | tr a-z A-Z`
NAS_NAME_2=`echo "${NAS_MODEL_2}" | tr a-z A-Z`

if [ -e arch/arm/configs/sequoia_defconfig ]; then
  NAS_VENDOR="Western Digital"
  NAS_VENDOR_SHORT=WD
  NAS_NAME="My Cloud"
  NAS_NAME_2=${NAS_NAME}

elif [ -e arch/arm/configs/alpine_defconfig ]; then
  NAS_VENDOR="Synology"
  NAS_VENDOR_SHORT=${NAS_VENDOR}
  NAS_NAME=`echo "${NAS_MODEL:0:5}" | tr a-z A-Z`${NAS_MODEL:5}
  NAS_NAME_2=`echo "${NAS_MODEL_2:0:5}" | tr a-z A-Z`${NAS_MODEL_2:5}

elif [ -e include/qnap ]; then
  NAS_VENDOR="Qnap"
  NAS_VENDOR_SHORT=${NAS_VENDOR}
  NAS_NAME=`echo "${NAS_MODEL:0:2}" | tr a-z A-Z`-${NAS_MODEL:2}
  NAS_NAME_2=`echo "${NAS_MODEL_2:0:2}" | tr a-z A-Z`-${NAS_MODEL_2:2}

elif [ -e arch/arm/configs/gfrg200_defconfig ]; then
  NAS_VENDOR="Google Fiber"
  NAS_VENDOR_SHORT="Google"
fi

NAS_NAME_SHORT=${NAS_NAME}
NAS_NAME_SHORT_2=${NAS_NAME_2}

if [ "${NAS_MODEL}" = "nas5xx" ]; then
  NAS_NAME="NAS520/NAS540/NAS542"
fi

lxcfg=debian/config/${NAS_ARCH}/config.${NAS_MODEL}

if [ "x$1" != "x" -a "x$2" != "x" ]; then
  axcfg=$1
  lxcfg=$2
fi

if $lxcfgfilter ; then
  cat ${axcfg} | \
grep -E 'COMCERTO|C2K|M86XXX|_MSP|OCF_|PFE|PL310_|'\
'ARM_ERRATA_775420|SCU_SPECULATIVE_LINE_FILLS|KERNEL_MODE_NEON|CPU_SPECULATIVE_ACCESS_DISABLED|'\
'L2X0_INSTRUCTION_ONLY|DW_DMAC|RAID_ZERO_COPY|MTD_ROOTFS_ROOT_DEV|MTD_ROOTFS_SPLIT|MTD_UBI_BEB_LIMIT|MTD_UBI_FASTMAP|ATHEROS_PHY|'\
'4BAY|SPI_DESIGNWARE|USB_XHCI_PLATFORM|DWC_OTG|CRASHLOG|PM_SYSFS_MANUAL|NET_ETHERIP|INET_IPSEC_OFFLOAD|INET6_IPSEC_OFFLOAD|'\
'MYBOOK|MYCLOUD|_WD_|CONFIG_NEW_LEDS=y|CONFIG_LEDS_.*=y|'\
'IPV6_ETHERIP|IP6_NF_TARGET_NPT|NET_SCH_ESFQ|NET_SCH_ESFQ_NFCT|NET_ACT_CONNMARK|NETFILTER_XT_MATCH_LAYER7|'\
'CONFIG_MV|MVEBU|MVSDIO|KIRKWOOD|'\
'CONFIG_ARCH|CONFIG_MACH|CONFIG_PLAT|CONFIG_SYS_|CONFIG_GENERIC|CONFIG_MIGHT|CONFIG_HAS_|CONFIG_HAVE|CONFIG_NEED|CONFIG_ARM|CONFIG_CPU|CONFIG_ZONE|'\
'CONFIG_VECTORS|CONFIG_IRQ|CONFIG_KTIME|CONFIG_STACK|CONFIG_LOCK|CONFIG_TRACE|CONFIG_HARDIRQ|CONFIG_RWSEM|CONFIG_DEFCONFIG|CONFIG_EXPERIMENTAL|'\
'CONFIG_BROKEN_ON_SMP|CONFIG_INIT|CONFIG_CROSS|CONFIG_LOCAL|CONFIG_KERNEL|CONFIG_DEFAULT|CONFIG_SWAP|CONFIG_SYSV|CONFIG_BSD_|CONFIG_FHANDLE|CONFIG_TASK|'\
'CONFIG_AUDIT|CONFIG_SPARSE|CONFIG_TREE|CONFIG_PREEMPT|CONFIG_RCU|CONFIG_IKCONFIG|CONFIG_LOG|CONFIG_BUG|CONFIG_EPOLL|CONFIG_CGROUP|CONFIG_PROC_|'\
'CONFIG_NAMESPACES|CONFIG_.*_NS|CONFIG_SCHED|CONFIG_SYSFS|CONFIG_RELAY|CONFIG_BLK_DEV_INITRD|CONFIG_RD_|CONFIG_SYSCTL|CONFIG_ANON|'\
'CONFIG_EXPERT|CONFIG_UID|CONFIG_KALLSYMS|CONFIG_HOTPLUG|CONFIG_PRINTK|CONFIG_BOOT_PRINTK_DELAY|CONFIG_ELF_|CONFIG_BASE_|CONFIG_FUTEX|CONFIG_SIGNAL|CONFIG_TIMER|'\
'CONFIG_EVENT|CONFIG_SHMEM|CONFIG_AIO|CONFIG_EMBEDDED|CONFIG_PERF_|CONFIG_VM_|CONFIG_PCI_QUIRKS|CONFIG_COMPAT_|CONFIG_SLAB|CONFIG_SLUB|'\
'CONFIG_OPROFILE|CONFIG_KPROBES|CONFIG_USE_|CONFIG_RT_|CONFIG_MODULE|CONFIG_STOP|CONFIG_BLOCK=|CONFIG_LBDAF|CONFIG_BLK_DEV_BSG|CONFIG_BLK_DEV_INTEGRITY|'\
'CONFIG_POSIX|CONFIG_RESOURCE|CONFIG_BLK_CGROUP|CONFIG_GCOV|CONFIG_MODVERSIONS|CONFIG_CONNECTOR|'\
'CONFIG_IOSCHED|CONFIG_INLINE|CONFIG_MUTEX|CONFIG_FREEZE|CONFIG_MMU|CONFIG_GPIO|CONFIG_DSPG_|CONFIG_SWP_|CONFIG_PCI|CONFIG_PCCARD|'\
'CONFIG_TICK|CONFIG_NO_|CONFIG_HIGH_|CONFIG_SMP|CONFIG_VMSPLIT|CONFIG_PAGE_|CONFIG_NR_CPUS|CONFIG_HZ|CONFIG_THUMB|CONFIG_AEABI|CONFIG_OABI|'\
'CONFIG_HIGHMEM|CONFIG_HW_|CONFIG_SELECT_|CONFIG_FLATMEM|CONFIG_FLAT_|CONFIG_PAGEFLAG|CONFIG_SPLIT|CONFIG_COMPACT|CONFIG_PHYS_|'\
'CONFIG_BOUNCE|CONFIG_VIRT_|CONFIG_KSM|CONFIG_CLEAN|CONFIG_FORCE_|CONFIG_ALIGNMENT_|CONFIG_UACCESS_|CONFIG_SECCOMP|CONFIG_CC_|'\
'CONFIG_DEPRECATED_|CONFIG_ZBOOT_|CONFIG_CMDLINE|CONFIG_KEXEC|CONFIG_CRASH|CONFIG_FPE|CONFIG_VFP|CONFIG_NEON|CONFIG_BINFMT|CONFIG_CORE|'\
'CONFIG_SUSPEND|CONFIG_PM|CONFIG_APM|CONFIG_NET=|CONFIG_PACKET|CONFIG_UNIX|CONFIG_MTD|CONFIG_M25PXX|CONFIG_PROFILING|CONFIG_OUTER_CACHE|CONFIG_CACHE|'\
'CONFIG_DEVTMPFS|CONFIG_STANDALONE|CONFIG_UEVENT_HELPER|CONFIG_FW_|CONFIG_FIRMWARE|CONFIG_EXTRA_FIRMWARE|CONFIG_PREVENT_FIRMWARE|'\
'CONFIG_DEVKMEM|CONFIG_USB_ARCH|CONFIG_ASYNC|CONFIG_DMA|CONFIG_IOMMU|'\
'CONFIG_FS_MBCACHE|CONFIG_FS_POSIX_ACL|CONFIG_FILE_LOCKING|CONFIG_FSNOTIFY|CONFIG_DNOTIFY|CONFIG_INOTIFY_USER|CONFIG_FANOTIFY|'\
'CONFIG_MISC_FILESYSTEMS=y|CONFIG_EXT2_|CONFIG_EXT3_|CONFIG_EXT4_|CONFIG_JFFS2|CONFIG_ROMFS|CONFIG_SQUASHFS|CONFIG_UBIFS_FS|CONFIG_TMPFS=y|CONFIG_.*_FS=y|'\
'CONFIG_ENABLE|CONFIG_FRAME_WARN|CONFIG_MAGIC_SYSRQ|CONFIG_STRIP_|CONFIG_UNUSED_SYMBOLS|CONFIG_DEBUG_|CONFIG_HEADERS|CONFIG_HARDLOCK|'\
'CONFIG_LKDTM|CONFIG_.*_TRACER|CONFIG_RING_BUFFER|CONFIG_DYNAMIC_DEBUG|CONFIG_ATOMIC64_SELFTEST|CONFIG_SAMPLES|CONFIG_TRACING|'\
'CONFIG_TEST_KSTRTOX|CONFIG_STRICT_DEVMEM|CONFIG_FTRACE|CONFIG_BRANCH_PROFILE|CONFIG_PROFILE_|CONFIG_BLK_DEV_IO_TRACE|CONFIG_KEYS|'\
'CONFIG_CRYPTO_HW|CONFIG_CRYPTO_DEV_|CONFIG_XOR_BLOCKS|'\
'CONFIG_BLK_DEV=|CONFIG_BLK_DEV_LOOP|CONFIG_MISC_DEVICES|CONFIG_SCSI=|CONFIG_BLK_DEV_SD|CONFIG_BLK_DEV_SR|CONFIG_CHR_DEV_SG|CONFIG_SCSI_|'\
'CONFIG_ATA=|CONFIG_PATA_|CONFIG_SATA_|CONFIG_ATA_|CONFIG_IDE|CONFIG_MD=|CONFIG_BLK_DEV_MD|CONFIG_MD_|CONFIG_BLK_DEV_DM|CONFIG_DM_|'\
'CONFIG_PARPORT|CONFIG_SERIO|CONFIG_SERIAL|CONFIG_DEVPORT|CONFIG_RAMOOPS|CONFIG_I2C|CONFIG_EEPROM|CONFIG_SPI|CONFIG_W1|CONFIG_POWER|CONFIG_HWMON|CONFIG_THERMAL|'\
'CONFIG_RTC_|CONFIG_WATCHDOG|CONFIG_.*_WATCHDOG|CONFIG_.*_WDT|CONFIG_SSB|'\
'CONFIG_BCMA|CONFIG_VGA_ARB|CONFIG_DRM|CONFIG_STUB_POULSBO|CONFIG_VGASTATE|CONFIG_VIDEO_OUTPUT_CONTROL|CONFIG_FB|CONFIG_BACKLIGHT_LCD|'\
'CONFIG_BINARY_PRINTF|CONFIG_MULTICORE_RAID|CONFIG_RAID|CONFIG_BITREVERSE|CONFIG_CRC|CONFIG_LIBCRC|'\
'CONFIG_ZLIB_|CONFIG_LZ4_|CONFIG_LZ4HC_|CONFIG_LZO_|CONFIG_XZ_|CONFIG_DECOMPRESS_|'\
'CONFIG_BCH|CONFIG_TEXTSEARCH|CONFIG_BTREE|CONFIG_NLATTR|CONFIG_AVERAGE|CONFIG_CORDIC|'\
'CONFIG_USB_COMMON|CONFIG_USB=|CONFIG_USB_DEBUG|CONFIG_USB_DEVICE_CLASS|CONFIG_USB_EHCI|CONFIG_USB_OHCI|CONFIG_USB_UHCI|CONFIG_USB_XHCI|CONFIG_USB_STORAGE=|'\
'CONFIG_.*_PARTITION=y|CONFIG_PARTITION_ADVANCED=y|CONFIG_.*_PARTITION_.*=y|CONFIG_.*_SUBPARTITION=y|'\
'CONFIG_FAT_DEFAULT|CONFIG_NLS=|CONFIG_NLS_DEFAULT|CONFIG_NLS_.*=|CONFIG_CRYPTO_.*=y|'\
'CONFIG_XFRM_.*=y|CONFIG_INET_.*=y|CONFIG_IPV6=y|CONFIG_INET6_.*=y|CONFIG_IPV6_.*=y|CONFIG_TCP_.*=y|CONFIG_STP=y|CONFIG_GARP=y|'\
'CONFIG_BRIDGE=y|CONFIG_VLAN_8021Q=y|CONFIG_WIRELESS_EXT=y|CONFIG_WEXT_.*=y|CONFIG_MII=y|CONFIG_PHYLIB=y|CONFIG_.*_PHY=y|'\
'CONFIG_ACCESSIBILITY|CONFIG_FUSION|CONFIG_INFINIBAND|CONFIG_MFD_|CONFIG_REGULATOR|CONFIG_VIRTIO|CONFIG_VMXNET|'\
'CONFIG_INPUT_TABLET|CONFIG_USB_APPLEDISPLAY|CONFIG_USB_DYNAMIC_MINORS|CONFIG_USB_OTG|CONFIG_NOP_USB|'\
'CONFIG_BUILDTIME|CONFIG_COMPILE|CONFIG_USELIB|CONFIG_MEMCG|CONFIG_FAIR_|CONFIG_CHECKPOINT|'\
'CONFIG_SGETMASK|'\
'CONFIG_SLOB|CONFIG_SYSTEM_|CONFIG_JUMP_|CONFIG_UPROBES|CONFIG_CLONE_|CONFIG_OLD_SIG|'\
'CONFIG_CFQ_GROUP|CONFIG_ASN1|CONFIG_UNINLINE|CONFIG_KUSER_HELPERS|'\
'CONFIG_MIGRATION|CONFIG_FRONTSWAP|CONFIG_ZBUD|CONFIG_ZSWAP|CONFIG_ZSMALLOC|CONFIG_SWIOTLB|'\
'CONFIG_ATAGS|CONFIG_HIBERNAT|'\
'CONFIG_BCACHE|'\
'CONFIG_READABLE_ASM|'\
'CONFIG_ASSOCIATIVE|CONFIG_CHECK_SIGNATURE|CONFIG_DQL|CONFIG_LRU_CACHE|CONFIG_CLZ_TAB|'\
'CONFIG_UNCOMPRESS_INCLUDE|CONFIG_EARLY_PRINTK=y|'\
'CONFIG_CLK.*=y|CONFIG_PIN.*=y|'\
'CONFIG_FONT.*=y|CONFIG_I2C.*=|CONFIG_NET_VENDOR_.*=y|'\
'CONFIG_HAMRADIO=y|CONFIG_AX25=|CONFIG_INPUT_JOYSTICK=y|CONFIG_INPUT_TOUCHSCREEN=y|'\
'CONFIG_NETWORK_FILESYSTEMS=y|CONFIG_NFS.*=y|CONFIG_PNFS_FILE_LAYOUT=y|CONFIG_ROOT_NFS=y|CONFIG_LOCKD=y|CONFIG_SUNRPC.*=y|CONFIG_EXPORTFS=y|'\
'CONFIG_HID_.*=|CONFIG_SENSORS_.*=|'\
'CONFIG_INPUT_AD714X=|CONFIG_INPUT_BMA150=|CONFIG_INPUT_MMA8450=|CONFIG_INPUT_MPU3050=|'\
'CONFIG_INPUT_GP2A=|CONFIG_INPUT_ATI_REMOTE2=|CONFIG_INPUT_KEYSPAN_REMOTE=|CONFIG_INPUT_YEALINK=|'\
'CONFIG_INPUT_CM109=|CONFIG_INPUT_UINPUT=|CONFIG_INPUT_PCF.*=|CONFIG_INPUT_GPIO.*=|'\
'CONFIG_INPUT_ADXL34X=|CONFIG_INPUT_IMS_PCU=|CONFIG_INPUT_CMA3000=|CONFIG_INPUT_SOC_.*=|'\
'CONFIG_AD525X_.*=|CONFIG_SGI_IOC4=|CONFIG_TIFM_.*=|CONFIG_ICS93.*=|CONFIG_ENCLOSURE_SERVICES=|CONFIG_HP_ILO=|'\
'CONFIG_APDS9802ALS=|CONFIG_ISL29.*=|CONFIG_HMC6352=|CONFIG_DS1682=|CONFIG_TI_DAC7512=|CONFIG_BMP085_.*=|'\
'CONFIG_BT_.*=|CONFIG_CAN_.*=|CONFIG_MMC.*=|CONFIG_SOC_CAMERA.*=|CONFIG_FRAMEBUFFER_CONSOLE.*=|'\
'CONFIG_SND_COMPRESS_OFFLOAD=|CONFIG_SND_SEQUENCER_OSS=y|CONFIG_SND_SOC.*=|CONFIG_SND_.*_SOC.*=|CONFIG_SND_.*_I2S=|CONFIG_SND_.*_SPI=|CONFIG_SND_SIMPLE_CARD=|'\
'CONFIG_RADIO_.*=|CONFIG_SMS_SDIO_DRV=|CONFIG_USB_DSBR=|'\
'CONFIG_RTL8.*=|CONFIG_ADM8211=|CONFIG_MWL8K=|CONFIG_WCN36XX=|CONFIG_B43.*=|CONFIG_IPW.*=|CONFIG_IWL.*=|'\
'CONFIG_.*_PCF50633=|CONFIG_PCF50633_.*=|CONFIG_SPMI=|'\
'^$|^#$| generat| Generat| subsystem| Subsystem| driver| Driver| support| Support| option| Option|'\
' module| Module| configuration| Configuration| device| Device| interface| Interface|'\
' adapter| Adapter| controller| Controller| expander| Expander| card| Card| chip| Chip|'\
' decoder| Decoder| encoder| Encoder| frontend| Frontend| tuner| Tuner| filesystem| Filesystem| File system|'\
' schedul| Schedul| debug| Debug| test| Test| help| Help| type| Type| feature| Feature| protocol| Protocol|'\
' port| Port| transport| Transport| hack| Hack| mode| Mode| clock| Clock| emulat| Emulat| trigger| Trigger|'\
' accounting| Performance| profiling| Implementation| Manage| scaling| Idle| format|'\
' target| match| Classification| Master| Slave| Backplane|Audio| depend| Client| Android| Cache|'\
' Encrypt| Digest| Cipher| Compress| Random| routine| General| Queueing| specific| console|'\
' Algorithm| System| infrastructure| because' > ${lxcfg}
else
  cp -p ${axcfg} ${lxcfg}
fi


echo "Patching config ${lxcfg}..."

cset="CONFIG_XFRM_IPCOMP
CONFIG_INET_ESP
CONFIG_INET_IPCOMP
CONFIG_INET_XFRM_TUNNEL
CONFIG_INET_TUNNEL
CONFIG_INET_XFRM_MODE_TRANSPORT
CONFIG_INET_XFRM_MODE_TUNNEL
CONFIG_INET6_AH
CONFIG_INET6_ESP
CONFIG_INET6_IPCOMP
CONFIG_INET6_XFRM_TUNNEL
CONFIG_INET6_TUNNEL
CONFIG_INET6_XFRM_MODE_TRANSPORT
CONFIG_INET6_XFRM_MODE_TUNNEL
CONFIG_INET6_XFRM_MODE_ROUTEOPTIMIZATION
CONFIG_IPV6_SIT
CONFIG_IPV6_TUNNEL
CONFIG_STP
CONFIG_GARP
CONFIG_BRIDGE
CONFIG_VLAN_8021Q
CONFIG_RFKILL
CONFIG_TUN
CONFIG_QUOTA_TREE
CONFIG_QFMT_V1
CONFIG_QFMT_V2"

for c in $cset ; do
  if grep -E '^'${c}'=y' ${lxcfg} > /dev/null ; then
    change_lxcfg $c m ${lxcfg}
  fi
done

if [ -e drivers/cpufreq/c2k-cpufreq.c ]; then
  extra_lxcfg ../configs/c2k-cpufreq-config
fi

#extra_lxcfg ../configs/nas5xx-config

if $lxcfgmidi ; then
  extra_lxcfg ../configs/base-to-midi-config
fi

if $lxcfgfull ; then
  extra_lxcfg ../configs/midi-to-full-config
fi

if $lxcfgextra ; then
  extra_lxcfg ../configs/full-to-extra-config
  extra_lxcfg ../configs/dvb-extra-config
  extra_lxcfg ../configs/snd-extra-config
fi

if $lxcfgdebug ; then
  extra_lxcfg ../configs/debug-config
fi


sed -i s/'CONFIG_INITRAMFS_SOURCE=.*'/'CONFIG_INITRAMFS_SOURCE=""'/g ${lxcfg}

change_lxcfg 'CONFIG_CROSS_COMPILE' n ${lxcfg}

change_lxcfg 'CONFIG_TMPFS_POSIX_ACL' y ${lxcfg}

change_lxcfg 'CONFIG_EXT4_FS_POSIX_ACL' y ${lxcfg}
change_lxcfg 'CONFIG_EXT4_FS_SECURITY' y ${lxcfg}

change_lxcfg 'CONFIG_BTRFS_FS_POSIX_ACL' y ${lxcfg}


change_lxcfg 'CONFIG_PARTITION_ADVANCED' y ${lxcfg}

change_lxcfg 'CONFIG_MAC_PARTITION' y ${lxcfg}

change_lxcfg 'CONFIG_EFI_PARTITION' y ${lxcfg}

#change_lxcfg 'CONFIG_KARMA_PARTITION' n ${lxcfg}

change_lxcfg 'CONFIG_BLK_DEV_NBD' m ${lxcfg}
change_lxcfg 'CONFIG_BLK_DEV_RAM' m ${lxcfg}
change_lxcfg 'CONFIG_BLK_DEV_RAM_COUNT' 16 ${lxcfg}
change_lxcfg 'CONFIG_BLK_DEV_RAM_SIZE' 4096 ${lxcfg}

change_lxcfg 'CONFIG_TIFM_CORE' n ${lxcfg}
change_lxcfg 'CONFIG_CB710_CORE' n ${lxcfg}


if $lxcfgmidi ; then
  true

# ipc_namespace.h, sched.h
  #change_lxcfg 'CONFIG_POSIX_MQUEUE' y ${lxcfg}
  #change_lxcfg 'CONFIG_POSIX_MQUEUE_SYSCTL' y ${lxcfg}

# sched.h
  #change_lxcfg 'CONFIG_TASKSTATS' y ${lxcfg}
  #change_lxcfg 'CONFIG_TASK_DELAY_ACCT' y ${lxcfg}
  #change_lxcfg 'CONFIG_TASK_XACCT' y ${lxcfg}
  #change_lxcfg 'CONFIG_TASK_IO_ACCOUNTING' y ${lxcfg}

  #change_lxcfg 'CONFIG_MODULE_FORCE_LOAD' y ${lxcfg}
  #change_lxcfg 'CONFIG_MODULE_FORCE_UNLOAD' y ${lxcfg}
  #change_lxcfg 'CONFIG_MODVERSIONS' y ${lxcfg}

  #change_lxcfg 'CONFIG_KEXEC' y ${lxcfg}
  #change_lxcfg 'CONFIG_ATAGS_PROC' y ${lxcfg}

# sched.h
  #change_lxcfg 'CONFIG_CORE_DUMP_DEFAULT_ELF_HEADERS' y ${lxcfg}


  change_lxcfg 'CONFIG_TCP_MD5SIG' n ${lxcfg}
  change_lxcfg 'CONFIG_DCB' n ${lxcfg}

  # NETCONSOLE enables NETPOLL
  #change_lxcfg 'CONFIG_NETCONSOLE' m ${lxcfg}
  #change_lxcfg 'CONFIG_NETCONSOLE_DYNAMIC' y ${lxcfg}
  #change_lxcfg 'CONFIG_NETPOLL' y ${lxcfg}
  #change_lxcfg 'CONFIG_NETPOLL_TRAP' n ${lxcfg}
  #change_lxcfg 'CONFIG_NET_POLL_CONTROLLER' y ${lxcfg}

  change_lxcfg 'CONFIG_SECURITY' y ${lxcfg}
  change_lxcfg 'CONFIG_SECURITYFS' n ${lxcfg}
  # debian build enables both
  change_lxcfg 'CONFIG_SECURITY_NETWORK' y ${lxcfg}
  change_lxcfg 'CONFIG_SECURITY_NETWORK_XFRM' y ${lxcfg}


  #change_lxcfg 'CONFIG_SCSI_SAS_ATTRS' m ${lxcfg}
  #change_lxcfg 'CONFIG_SCSI_SAS_LIBSAS' m ${lxcfg}
  #change_lxcfg 'CONFIG_SCSI_SAS_ATA' y ${lxcfg}
  #change_lxcfg 'CONFIG_SCSI_SAS_HOST_SMP' y ${lxcfg}

  #change_lxcfg 'CONFIG_SCSI_DH' m ${lxcfg}

  change_lxcfg 'CONFIG_BLK_DEV_RBD' m ${lxcfg}
fi


allphyset=y
onephyyes=n

getphycfg CONFIG_ATHEROS_PHY
phya=$valx

getphycfg CONFIG_BROADCOM_PHY
phyb=$valx

getphycfg CONFIG_MARVELL_PHY
phym=$valx

getphycfg CONFIG_REALTEK_PHY
phyr=$valx

if [ $allphyset = y -a $onephyyes = y ]; then
  echo "PHY already set."
else
  echo "PHY"

  if [ -e include/qnap -o -e arch/arm/configs/gfrg200_defconfig ]; then
    change_lxcfg 'CONFIG_ATHEROS_PHY' y ${lxcfg}
  else
    change_lxcfg 'CONFIG_ATHEROS_PHY' m ${lxcfg}
  fi

  if [ -e arch/arm/configs/sequoia_defconfig ]; then
    change_lxcfg 'CONFIG_BROADCOM_PHY' y ${lxcfg}
  else
    change_lxcfg 'CONFIG_BROADCOM_PHY' m ${lxcfg}
  fi

  if [ -e arch/arm/configs/gfsc100_defconfig ]; then
    change_lxcfg 'CONFIG_MARVELL_PHY' y ${lxcfg}
  else
    change_lxcfg 'CONFIG_MARVELL_PHY' m ${lxcfg}
  fi

  if grep 'ZYXEL_' drivers/ata/libata-scsi.c > /dev/null ; then
    change_lxcfg 'CONFIG_REALTEK_PHY' y ${lxcfg}
  else
    change_lxcfg 'CONFIG_REALTEK_PHY' m ${lxcfg}
  fi

  allphyset=y
  onephyyes=n

  getphycfg CONFIG_ATHEROS_PHY
  phya=$valx

  getphycfg CONFIG_BROADCOM_PHY
  phyb=$valx

  getphycfg CONFIG_MARVELL_PHY
  phym=$valx

  getphycfg CONFIG_REALTEK_PHY
  phyr=$valx
fi


if $lxcfgmidi ; then
  #change_lxcfg 'CONFIG_ATH6KL_SDIO' m ${lxcfg}
  change_lxcfg 'CONFIG_ATH6KL_USB' m ${lxcfg}
  change_lxcfg 'CONFIG_ATH6KL_TRACING' n ${lxcfg}

  change_lxcfg 'CONFIG_HID_ELO' m ${lxcfg}
  change_lxcfg 'CONFIG_HID_HUION' m ${lxcfg}
  change_lxcfg 'CONFIG_HID_RMI' m ${lxcfg}
  #change_lxcfg 'CONFIG_HID_THINGM' m ${lxcfg}
  change_lxcfg 'CONFIG_HID_TIVO' m ${lxcfg}

  #change_lxcfg 'CONFIG_UHID' m ${lxcfg}

  change_lxcfg 'CONFIG_TOUCHSCREEN_SUR40' m ${lxcfg}

  #change_lxcfg 'CONFIG_DM_LOG_USERSPACE' m ${lxcfg}

  #change_lxcfg 'CONFIG_DM_DELAY' m ${lxcfg}
  #change_lxcfg 'CONFIG_DM_UEVENT' y ${lxcfg}
  #change_lxcfg 'CONFIG_DM_FLAKEY' m ${lxcfg}

  #change_lxcfg 'CONFIG_CFG80211_DEFAULT_PS' y ${lxcfg}

  # selected by HOSTAP, LIBIPW, IPW2100, IPW2200
  #change_lxcfg 'CONFIG_LIB80211_CRYPT_WEP' m ${lxcfg}
  #change_lxcfg 'CONFIG_LIB80211_CRYPT_CCMP' m ${lxcfg}
  #change_lxcfg 'CONFIG_LIB80211_CRYPT_TKIP' m ${lxcfg}

  if [ ! -e arch/arm/configs/alpine_defconfig ]; then
    true
  fi
fi


echo "CRYPTO"
change_lxcfg 'CONFIG_CRYPTO_CTS' m ${lxcfg}


echo "FS"
change_lxcfg 'CONFIG_AUTOFS4_FS' m ${lxcfg}

change_lxcfg 'CONFIG_NTFS_FS' m ${lxcfg}
change_lxcfg 'CONFIG_NTFS_RW' y ${lxcfg}

change_lxcfg 'CONFIG_DNOTIFY' y ${lxcfg}

change_lxcfg 'CONFIG_FANOTIFY' y ${lxcfg}

nfsfs=m
if grep 'CONFIG_NFS_FS=' ${lxcfg} ; then
nfsfs=`grep 'CONFIG_NFS_FS=' ${lxcfg} | cut -d '=' -f 2`
fi

change_lxcfg 'CONFIG_NFS_FS' ${nfsfs} ${lxcfg}

change_lxcfg 'CONFIG_NFS_V4_1' y ${lxcfg}

change_lxcfg 'CONFIG_PNFS_FILE_LAYOUT' ${nfsfs} ${lxcfg}
change_lxcfg 'CONFIG_PNFS_BLOCK' ${nfsfs} ${lxcfg}

change_lxcfg 'CONFIG_NFS_FSCACHE' y ${lxcfg}

change_lxcfg 'CONFIG_NFSD' ${nfsfs} ${lxcfg}

change_lxcfg 'CONFIG_LOCKD' ${nfsfs} ${lxcfg}

change_lxcfg 'CONFIG_NFS_V4' y ${lxcfg}
change_lxcfg 'CONFIG_NFSD_V3' y ${lxcfg}
change_lxcfg 'CONFIG_NFSD_V4' y ${lxcfg}

change_lxcfg 'CONFIG_NFS_V3_ACL' y ${lxcfg}
change_lxcfg 'CONFIG_NFSD_V2_ACL' y ${lxcfg}
change_lxcfg 'CONFIG_NFSD_V3_ACL' y ${lxcfg}

change_lxcfg 'CONFIG_NFS_ACL_SUPPORT' ${nfsfs} ${lxcfg}

change_lxcfg 'CONFIG_SUNRPC' ${nfsfs} ${lxcfg}
change_lxcfg 'CONFIG_SUNRPC_GSS' ${nfsfs} ${lxcfg}

change_lxcfg 'CONFIG_RPCSEC_GSS_KRB5' m ${lxcfg}

change_lxcfg 'CONFIG_CIFS' m ${lxcfg}

change_lxcfg 'CONFIG_CIFS_FSCACHE' y ${lxcfg}

change_lxcfg 'CONFIG_CIFS_UPCALL' y ${lxcfg}
change_lxcfg 'CONFIG_CIFS_XATTR' y ${lxcfg}
change_lxcfg 'CONFIG_CIFS_POSIX' y ${lxcfg}
change_lxcfg 'CONFIG_CIFS_DFS_UPCALL' y ${lxcfg}
change_lxcfg 'CONFIG_CIFS_ACL' y ${lxcfg}

#change_lxcfg 'CONFIG_CIFS_WEAK_PW_HASH' y ${lxcfg}


if $lxcfgmidi ; then
  echo "Patching config ${lxcfg}..."

  echo "DM"
  change_lxcfg 'CONFIG_BLK_DEV_DM' y ${lxcfg}

  change_lxcfg 'CONFIG_DM_DEBUG' n ${lxcfg}
  change_lxcfg 'CONFIG_DM_CRYPT' m ${lxcfg}
  change_lxcfg 'CONFIG_DM_DELAY' n ${lxcfg}
  change_lxcfg 'CONFIG_DM_UEVENT' n ${lxcfg}
  change_lxcfg 'CONFIG_DM_FLAKEY' n ${lxcfg}

  change_lxcfg 'CONFIG_DM_LOG_USERSPACE' n ${lxcfg}

  echo "FS"
 #
 # File systems
 #

  change_lxcfg 'CONFIG_BTRFS_FS' m ${lxcfg}

  change_lxcfg 'CONFIG_EXPORTFS' y ${lxcfg}

  change_lxcfg 'CONFIG_QUOTA' y ${lxcfg}
  change_lxcfg 'CONFIG_QUOTA_NETLINK_INTERFACE' n ${lxcfg}
  change_lxcfg 'CONFIG_PRINT_QUOTA_WARNING' n ${lxcfg}
  change_lxcfg 'CONFIG_QUOTA_DEBUG' n ${lxcfg}

  change_lxcfg 'CONFIG_QUOTA_TREE' m ${lxcfg}
  change_lxcfg 'CONFIG_QFMT_V1' m ${lxcfg}
  change_lxcfg 'CONFIG_QFMT_V2' m ${lxcfg}
  change_lxcfg 'CONFIG_QUOTACTL' y ${lxcfg}

  change_lxcfg 'CONFIG_FUSE_FS' m ${lxcfg}
 
 #
 # Caches
 #
  change_lxcfg 'CONFIG_FSCACHE' n ${lxcfg}

  change_lxcfg 'CONFIG_FSCACHE_STATS' n ${lxcfg}

#  change_lxcfg 'CONFIG_FSCACHE_HISTOGRAM is not set
#  change_lxcfg 'CONFIG_FSCACHE_DEBUG is not set
#  change_lxcfg 'CONFIG_FSCACHE_OBJECT_LIST is not set

  change_lxcfg 'CONFIG_CACHEFILES' n ${lxcfg}
#  change_lxcfg 'CONFIG_CACHEFILES_DEBUG is not set
#  change_lxcfg 'CONFIG_CACHEFILES_HISTOGRAM is not set
 
 #
 # CD-ROM/DVD Filesystems
 #
  change_lxcfg 'CONFIG_ISO9660_FS' m ${lxcfg}
  change_lxcfg 'CONFIG_JOLIET' y ${lxcfg}

  change_lxcfg 'CONFIG_ZISOFS' n ${lxcfg}
  change_lxcfg 'CONFIG_UDF_FS' m ${lxcfg}
  change_lxcfg 'CONFIG_UDF_NLS' y ${lxcfg}
 
 #
 # DOS/FAT/NT Filesystems
 #

  change_lxcfg 'CONFIG_FAT_FS' y ${lxcfg}
  change_lxcfg 'CONFIG_MSDOS_FS' y ${lxcfg}
  change_lxcfg 'CONFIG_VFAT_FS' y ${lxcfg}

  change_lxcfg 'CONFIG_HFSPLUS_FS' y ${lxcfg}

  change_lxcfg 'CONFIG_UBIFS_FS' y ${lxcfg}

#  change_lxcfg 'CONFIG_UBIFS_FS_XATTR' y ${lxcfg}
#  change_lxcfg 'CONFIG_UBIFS_FS_ADVANCED_COMPR' y ${lxcfg}

#  change_lxcfg 'CONFIG_MAC_PARTITION' n ${lxcfg}

  echo "other"
  change_lxcfg 'CONFIG_RAID_ZERO_COPY' y ${lxcfg}

  change_lxcfg 'CONFIG_XOR_BLOCKS' y ${lxcfg}
  change_lxcfg 'CONFIG_ASYNC_CORE' y ${lxcfg}
  change_lxcfg 'CONFIG_ASYNC_MEMCPY' y ${lxcfg}
  change_lxcfg 'CONFIG_ASYNC_XOR' y ${lxcfg}
  change_lxcfg 'CONFIG_ASYNC_PQ' y ${lxcfg}
  change_lxcfg 'CONFIG_ASYNC_RAID6_RECOV' y ${lxcfg}

  change_lxcfg 'CONFIG_CRYPTO_ECB' y ${lxcfg}
  change_lxcfg 'CONFIG_CRYPTO_CRC32C' y ${lxcfg}

#  change_lxcfg 'CONFIG_CRYPTO_FCRYPT' n ${lxcfg}

  change_lxcfg 'CONFIG_RAID6_PQ' y ${lxcfg}

  change_lxcfg 'CONFIG_CRC_CCITT' y ${lxcfg}

  #change_lxcfg 'CONFIG_CRC_T10DIF' m ${lxcfg}
  #change_lxcfg 'CONFIG_CRC7' m ${lxcfg}

  echo "GRE"

  if [ ! -e arch/arm/configs/alpine_defconfig ]; then
    true
  fi

  echo "NET_SCH"
  change_lxcfg 'CONFIG_NET_SCHED' y ${lxcfg}

  change_lxcfg 'CONFIG_NET_SCH_FIFO' y ${lxcfg}
fi


if $lxcfgfull ; then
  true

  change_lxcfg 'CONFIG_NET_EMATCH' y ${lxcfg}
  change_lxcfg 'CONFIG_NET_EMATCH_TEXT' m ${lxcfg}

  echo "NETFILTER"

  change_lxcfg 'CONFIG_NF_TABLES_BRIDGE' m ${lxcfg}
  change_lxcfg 'CONFIG_NFT_BRIDGE_META' m ${lxcfg}
fi


if $lxcfgmidi ; then
  #change_lxcfg 'CONFIG_IPV6_ROUTER_PREF' y ${lxcfg}
  #change_lxcfg 'CONFIG_IPV6_ROUTE_INFO' y ${lxcfg}
  #change_lxcfg 'CONFIG_IPV6_OPTIMISTIC_DAD' y ${lxcfg}
  #change_lxcfg 'CONFIG_IPV6_MIP6' m ${lxcfg}
  #change_lxcfg 'CONFIG_IPV6_MROUTE_MULTIPLE_TABLES' y ${lxcfg}

  change_lxcfg 'CONFIG_NETWORK_SECMARK' y ${lxcfg}

  change_lxcfg 'CONFIG_NETFILTER' y ${lxcfg}

  change_lxcfg 'CONFIG_NETFILTER_NETLINK_ACCT' m ${lxcfg}
  change_lxcfg 'CONFIG_NETFILTER_NETLINK_QUEUE_CT' y ${lxcfg}
  change_lxcfg 'CONFIG_NETFILTER_SYNPROXY' m ${lxcfg}

  # selected by IP_NF_IPTABLES IP_NF_ARPTABLES IP6_NF_IPTABLES BRIDGE_NF_EBTABLES
  change_lxcfg 'CONFIG_NETFILTER_XTABLES' m ${lxcfg}

  change_lxcfg 'CONFIG_NF_CONNTRACK' m ${lxcfg}
  # debian build selects both
  change_lxcfg 'CONFIG_NF_CONNTRACK_SECMARK' y ${lxcfg}
  change_lxcfg 'CONFIG_NF_CONNTRACK_EVENTS' y ${lxcfg}

  change_lxcfg 'CONFIG_NET_CLS_ROUTE4' m ${lxcfg}
  change_lxcfg 'CONFIG_NET_CLS_FW' m ${lxcfg}
  change_lxcfg 'CONFIG_NET_CLS_U32' m ${lxcfg}
  change_lxcfg 'CONFIG_NET_CLS_CGROUP' m ${lxcfg}
  change_lxcfg 'CONFIG_NET_CLS_ACT' y ${lxcfg}
  change_lxcfg 'CONFIG_NET_CLS_IND' y ${lxcfg}

else

  change_lxcfg 'CONFIG_NET_CLS_CGROUP' n ${lxcfg}
fi


if $lxcfgfull ; then
  true

  change_lxcfg 'CONFIG_TCP_CONG_ADVANCED' y ${lxcfg}

  change_lxcfg 'CONFIG_IP_SET' m ${lxcfg}

  change_lxcfg 'CONFIG_IP_VS' m ${lxcfg}
  change_lxcfg 'CONFIG_IP_VS_IPV6' y ${lxcfg}

  change_lxcfg 'CONFIG_NETFILTER_XT_TARGET_TPROXY' m ${lxcfg}

  change_lxcfg 'CONFIG_NETFILTER_XT_MATCH_SOCKET' m ${lxcfg}

  #if $lxcfgfull ; then
  #fi

  echo "ISDN"
  change_lxcfg 'CONFIG_ISDN' y ${lxcfg}
  change_lxcfg 'CONFIG_ISDN_I4L' n ${lxcfg}
  change_lxcfg 'CONFIG_ISDN_CAPI' n ${lxcfg}
  change_lxcfg 'CONFIG_ISDN_DRV_GIGASET' n ${lxcfg}
  change_lxcfg 'CONFIG_HYSDN' n ${lxcfg}
  change_lxcfg 'CONFIG_MISDN' n ${lxcfg}

else

  change_lxcfg 'CONFIG_NET_EMATCH' n ${lxcfg}
  change_lxcfg 'CONFIG_NET_EMATCH_TEXT' n ${lxcfg}

  change_lxcfg 'CONFIG_TCP_CONG_ADVANCED' n ${lxcfg}

  change_lxcfg 'CONFIG_IP_SET' n ${lxcfg}

  change_lxcfg 'CONFIG_IP_VS' n ${lxcfg}
  change_lxcfg 'CONFIG_IP_VS_IPV6' n ${lxcfg}

  change_lxcfg 'CONFIG_NF_CT_PROTO_GRE' n ${lxcfg}

  change_lxcfg 'CONFIG_NF_CONNTRACK_BROADCAST' n ${lxcfg}

  change_lxcfg 'CONFIG_NETFILTER_XT_TARGET_TPROXY' n ${lxcfg}

  change_lxcfg 'CONFIG_NETFILTER_XT_MATCH_SOCKET' n ${lxcfg}

  change_lxcfg 'CONFIG_NF_NAT_PROTO_DCCP' n ${lxcfg}
  change_lxcfg 'CONFIG_NF_NAT_PROTO_SCTP' n ${lxcfg}
fi


if $lxcfgmidi ; then
  echo '"is not set" sections'
  #change_lxcfg '# CONFIG_XFRM.* is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_INET.* is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_NET_SCH_.* is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_NET_CLS_.* is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_WIRELESS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_CEPH_LIB is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_DEVTMPFS is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_BLK_DEV_.* is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_SCSI_TGT is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_MD_.* is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_TARGET_CORE is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_BONDING is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_NET_VENDOR_.* is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_REALTEK_PHY is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_PPP is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_WLAN is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_ISDN is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_I2C is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_HWMON_.* is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_SENSORS_.* is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_WATCHDOG is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_HID_SUPPORT is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_USB_PRINTER is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_USB_UAS is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_LEDS_.* is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_ASYNC_TX_DMA is not set' - ${lxcfg}

  change_lxcfg '# CONFIG_EXT2_FS_SECURITY is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_REISERFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_JFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_XFS_QUOTA is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_XFS_RT is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_GFS2_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_BTRFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_NILFS2_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_FSCACHE_STATS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_CACHEFILES_HISTOGRAM is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_ISO9660_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_UDF_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_NTFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_CONFIGFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_ADFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_AFFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_HFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_HFSPLUS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_BEFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_BFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_EFS_FS is not set' - ${lxcfg}

  #change_lxcfg '# CONFIG_JFFS2_FS is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_UBIFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_LOGFS is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_CRAMFS is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_SQUASHFS is not set' - ${lxcfg}

  change_lxcfg '# CONFIG_VXFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_MINIX_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_OMFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_HPFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_QNX4FS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_QNX6FS_FS is not set' - ${lxcfg}
  #change_lxcfg '# CONFIG_ROMFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_SYSV_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_UFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_NFS_V4 is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_NFS_FSCACHE is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_NFSD_V4 is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_CEPH_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_CIFS_FSCACHE is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_NCP_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_CODA_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_AFS_FS is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_MAGIC_SYSRQ is not set' - ${lxcfg}
  change_lxcfg '# CONFIG_KEYS is not set' - ${lxcfg}


  echo "other"
  change_lxcfg 'CONFIG_KEYS_DEBUG_PROC_KEYS' n ${lxcfg}

  change_lxcfg 'CONFIG_B43_DEBUG' n ${lxcfg}
  change_lxcfg 'CONFIG_B43LEGACY_DEBUG' n ${lxcfg}

  change_lxcfg 'CONFIG_MLX4_EN' n ${lxcfg}
  change_lxcfg 'CONFIG_MLX4_CORE' n ${lxcfg}


  echo "BLK"

  change_lxcfg 'CONFIG_BLK_DEV_INTEGRITY' n ${lxcfg}

  change_lxcfg 'CONFIG_BLK_DEV_LOOP' y ${lxcfg}
#  change_lxcfg 'CONFIG_BLK_DEV_NBD' n ${lxcfg}
#  change_lxcfg 'CONFIG_BLK_DEV_RAM' n ${lxcfg}
#  change_lxcfg 'CONFIG_BLK_DEV_RBD' n ${lxcfg}

  change_lxcfg 'CONFIG_BLK_DEV_SR' y ${lxcfg}

  echo "MD"
#  change_lxcfg 'CONFIG_MD_AUTODETECT' n ${lxcfg}
  change_lxcfg 'CONFIG_MD_LINEAR' y ${lxcfg}
  change_lxcfg 'CONFIG_MD_RAID0' y ${lxcfg}
  change_lxcfg 'CONFIG_MD_RAID10' y ${lxcfg}
  change_lxcfg 'CONFIG_MD_RAID456' y ${lxcfg}
#  change_lxcfg 'CONFIG_BLK_DEV_DM_BUILTIN' y ${lxcfg}
fi


echo "other"
# include kernel config as /proc/config.gz
change_lxcfg 'CONFIG_IKCONFIG' y ${lxcfg}
change_lxcfg 'CONFIG_IKCONFIG_PROC' y ${lxcfg}

echo "CGROUP"
change_lxcfg 'CONFIG_CGROUPS' y ${lxcfg}
change_lxcfg 'CONFIG_CGROUP_DEBUG' n ${lxcfg}
change_lxcfg 'CONFIG_CGROUP_FREEZER' n ${lxcfg}
change_lxcfg 'CONFIG_CGROUP_DEVICE' y ${lxcfg}
change_lxcfg 'CONFIG_CPUSETS' y ${lxcfg}
change_lxcfg 'CONFIG_PROC_PID_CPUSET' y ${lxcfg}
change_lxcfg 'CONFIG_CGROUP_CPUACCT' y ${lxcfg}
change_lxcfg 'CONFIG_RESOURCE_COUNTERS' n ${lxcfg}
change_lxcfg 'CONFIG_CGROUP_PERF' n ${lxcfg}


if $lxcfgmidi ; then
  #change_lxcfg 'CONFIG_CGROUP_SCHED' n ${lxcfg}
  change_lxcfg 'CONFIG_CGROUP_SCHED' y ${lxcfg}
  change_lxcfg 'CONFIG_FAIR_GROUP_SCHED' y ${lxcfg}
  change_lxcfg 'CONFIG_RT_GROUP_SCHED' n ${lxcfg}

  #change_lxcfg 'CONFIG_SCHED_AUTOGROUP' n ${lxcfg}

  change_lxcfg 'CONFIG_BLK_CGROUP' n ${lxcfg}


  echo "NET"
  change_lxcfg 'CONFIG_ETHERNET' y ${lxcfg}

  change_lxcfg 'CONFIG_NET_VENDOR_INTEL' y ${lxcfg}
  change_lxcfg 'CONFIG_E100' n ${lxcfg}
  change_lxcfg 'CONFIG_E1000' n ${lxcfg}
  change_lxcfg 'CONFIG_E1000E' n ${lxcfg}
  change_lxcfg 'CONFIG_IGB' n ${lxcfg}
  change_lxcfg 'CONFIG_IGBVF' n ${lxcfg}

  change_lxcfg 'CONFIG_NET_VENDOR_QLOGIC' y ${lxcfg}
  change_lxcfg 'CONFIG_QLA3XXX' n ${lxcfg}
  change_lxcfg 'CONFIG_QLCNIC' n ${lxcfg}
  change_lxcfg 'CONFIG_QLGE' n ${lxcfg}
  change_lxcfg 'CONFIG_NETXEN_NIC' n ${lxcfg}

  change_lxcfg 'CONFIG_ACENIC' n ${lxcfg}
  change_lxcfg 'CONFIG_PCNET32' n ${lxcfg}
  change_lxcfg 'CONFIG_ATL2' n ${lxcfg}
  change_lxcfg 'CONFIG_ATL1' n ${lxcfg}
  change_lxcfg 'CONFIG_ATL1E' n ${lxcfg}
  change_lxcfg 'CONFIG_ATL1C' n ${lxcfg}
  change_lxcfg 'CONFIG_BNX2' n ${lxcfg}
  change_lxcfg 'CONFIG_CNIC' n ${lxcfg}
  change_lxcfg 'CONFIG_TIGON3' n ${lxcfg}
  change_lxcfg 'CONFIG_BNX2X' n ${lxcfg}
  change_lxcfg 'CONFIG_BNA' n ${lxcfg}
  change_lxcfg 'CONFIG_CHELSIO_T1' n ${lxcfg}
  change_lxcfg 'CONFIG_CHELSIO_T3' n ${lxcfg}
  change_lxcfg 'CONFIG_CHELSIO_T4' n ${lxcfg}
  change_lxcfg 'CONFIG_CHELSIO_T4VF' n ${lxcfg}
  change_lxcfg 'CONFIG_ENIC' n ${lxcfg}
  change_lxcfg 'CONFIG_DL2K' n ${lxcfg}
  change_lxcfg 'CONFIG_BE2NET' n ${lxcfg}
  change_lxcfg 'CONFIG_S2IO' n ${lxcfg}
  change_lxcfg 'CONFIG_VXGE' n ${lxcfg}
  change_lxcfg 'CONFIG_IXGB' n ${lxcfg}
  change_lxcfg 'CONFIG_IXGBE' n ${lxcfg}
  change_lxcfg 'CONFIG_IXGBEVF' n ${lxcfg}
  change_lxcfg 'CONFIG_SKGE' n ${lxcfg}
  change_lxcfg 'CONFIG_SKY2' n ${lxcfg}
  change_lxcfg 'CONFIG_KS8842' n ${lxcfg}
  change_lxcfg 'CONFIG_KS8851' n ${lxcfg}
  change_lxcfg 'CONFIG_KS8851_MLL' n ${lxcfg}
  change_lxcfg 'CONFIG_KSZ884X_PCI' n ${lxcfg}
  change_lxcfg 'CONFIG_ENC28J60' n ${lxcfg}
  change_lxcfg 'CONFIG_MYRI10GE' n ${lxcfg}
  change_lxcfg 'CONFIG_NS83820' n ${lxcfg}
  change_lxcfg 'CONFIG_R8169' n ${lxcfg}
  change_lxcfg 'CONFIG_R6040' n ${lxcfg}
  change_lxcfg 'CONFIG_SC92031' n ${lxcfg}
  change_lxcfg 'CONFIG_SIS190' n ${lxcfg}
  change_lxcfg 'CONFIG_SMSC9420' n ${lxcfg}
  change_lxcfg 'CONFIG_CASSINI' n ${lxcfg}
  change_lxcfg 'CONFIG_NIU' n ${lxcfg}
  change_lxcfg 'CONFIG_TEHUTI' n ${lxcfg}
  change_lxcfg 'CONFIG_TLAN' n ${lxcfg}
  change_lxcfg 'CONFIG_VIA_VELOCITY' n ${lxcfg}

  change_lxcfg 'CONFIG_RTL8180' n ${lxcfg}
  change_lxcfg 'CONFIG_ADM8211' n ${lxcfg}
  change_lxcfg 'CONFIG_MWL8K' n ${lxcfg}
  change_lxcfg 'CONFIG_B43' n ${lxcfg}
  change_lxcfg 'CONFIG_B43LEGACY' n ${lxcfg}
  change_lxcfg 'CONFIG_BRCMSMAC' n ${lxcfg}
  change_lxcfg 'CONFIG_HOSTAP' n ${lxcfg}
  change_lxcfg 'CONFIG_IPW2200' n ${lxcfg}
  change_lxcfg 'CONFIG_IWLWIFI' n ${lxcfg}
  change_lxcfg 'CONFIG_IWL4965' n ${lxcfg}
  change_lxcfg 'CONFIG_IWL3945' n ${lxcfg}
  change_lxcfg 'CONFIG_LIBERTAS' n ${lxcfg}
  change_lxcfg 'CONFIG_RTL8192CE' n ${lxcfg}
  change_lxcfg 'CONFIG_RTL8192SE' n ${lxcfg}
  change_lxcfg 'CONFIG_RTL8192DE' n ${lxcfg}
  change_lxcfg 'CONFIG_WL1251' n ${lxcfg}
  change_lxcfg 'CONFIG_WL12XX_MENU' n ${lxcfg}

  change_lxcfg 'CONFIG_REGULATOR' y ${lxcfg}
  change_lxcfg 'CONFIG_REGULATOR_DEBUG' n ${lxcfg}
  # REGULATOR_TPS65023 enables REGMAP
  #change_lxcfg 'CONFIG_REGULATOR_TPS65023' m ${lxcfg}
  change_lxcfg 'CONFIG_REGULATOR_TPS65023' n ${lxcfg}

  echo "I2C"
  change_lxcfg 'CONFIG_I2C' y ${lxcfg}
 
  change_lxcfg 'CONFIG_I2C_BOARDINFO' y ${lxcfg}
  change_lxcfg 'CONFIG_I2C_CHARDEV' y ${lxcfg}
  change_lxcfg 'CONFIG_I2C_SMBUS' y ${lxcfg}

  change_lxcfg 'CONFIG_I2C_PCA_PLATFORM' m ${lxcfg}
  change_lxcfg 'CONFIG_I2C_SIMTEC' m ${lxcfg}

  change_lxcfg 'CONFIG_I2C_PARPORT_LIGHT' m ${lxcfg}
fi


if [ -e arch/arm/configs/sequoia_defconfig ]; then
  echo "misc"
  change_lxcfg 'CONFIG_ICS932S401' n ${lxcfg}
  change_lxcfg 'CONFIG_APDS9802ALS' n ${lxcfg}
  change_lxcfg 'CONFIG_ISL29003' n ${lxcfg}
  change_lxcfg 'CONFIG_ISL29020' n ${lxcfg}
  change_lxcfg 'CONFIG_HMC6352' n ${lxcfg}
  change_lxcfg 'CONFIG_DS1682' n ${lxcfg}
  change_lxcfg 'CONFIG_BMP085' n ${lxcfg}

  change_lxcfg 'CONFIG_EEPROM_AT24' n ${lxcfg}
  change_lxcfg 'CONFIG_EEPROM_LEGACY' n ${lxcfg}
  change_lxcfg 'CONFIG_EEPROM_MAX6875' n ${lxcfg}

  echo "MFD"
  change_lxcfg 'CONFIG_MFD_WM8400' n ${lxcfg}
  change_lxcfg 'CONFIG_MFD_WM831X_I2C' n ${lxcfg}
  change_lxcfg 'CONFIG_MFD_WM8994' n ${lxcfg}
  change_lxcfg 'CONFIG_MFD_PCF50633' n ${lxcfg}


  change_lxcfg 'CONFIG_SENSORS_LIS3_I2C' n ${lxcfg}

  echo "I2C"
  change_lxcfg 'CONFIG_I2C_COMPAT' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_MUX' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_HELPER_AUTO' n ${lxcfg}

#
# I2C Algorithms
#
  change_lxcfg 'CONFIG_I2C_ALGOBIT' m ${lxcfg}
  change_lxcfg 'CONFIG_I2C_ALGOPCF' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_ALGOPCA' m ${lxcfg}

#
# I2C Hardware Bus support
#

#
# PC SMBus host controller drivers
#
  change_lxcfg 'CONFIG_I2C_ALI1535' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_ALI1563' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_ALI15X3' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_AMD756' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_AMD8111' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_I801' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_ISCH' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_PIIX4' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_NFORCE2' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_SIS5595' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_SIS630' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_SIS96X' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_VIA' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_VIAPRO' n ${lxcfg}

#
# I2C system bus drivers (mostly embedded / system-on-chip)
#
  change_lxcfg 'CONFIG_I2C_GPIO' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_INTEL_MID' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_OCORES' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_PCA_PLATFORM' m ${lxcfg}
  change_lxcfg 'CONFIG_I2C_PXA_PCI' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_SIMTEC' m ${lxcfg}
  change_lxcfg 'CONFIG_I2C_XILINX' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_EG20T' n ${lxcfg}

#
# External I2C/SMBus adapter drivers
#
  change_lxcfg 'CONFIG_I2C_DIOLAN_U2C' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_PARPORT_LIGHT' m ${lxcfg}
  change_lxcfg 'CONFIG_I2C_TAOS_EVM' n ${lxcfg}
  change_lxcfg 'CONFIG_I2C_TINY_USB' n ${lxcfg}

#
# Other I2C/SMBus bus drivers
#
  change_lxcfg 'CONFIG_I2C_STUB' n ${lxcfg}
fi


lxcfgnsr=false
if [ -e arch/arm/configs/sequoia_defconfig ]; then
  lxcfgnsr=true
elif $lxcfgextra ; then
  lxcfgnsr=true
fi

if $lxcfgnsr ; then
  echo "SENSORS"

  change_lxcfg 'CONFIG_SENSORS_TSL2550' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_BH1780' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_BH1770' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_APDS990X' n ${lxcfg}

  change_lxcfg 'CONFIG_SENSORS_AD7414' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_AD7418' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_ADM1029' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_ADM9240' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_ADT7411' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_ADT7462' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_ADT7470' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_ADT7475' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_ASC7621' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_ATXP1' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_DS620' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_F75375S' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_G760A' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_LINEAGE' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_LM73' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_LM93' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_LTC4151' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_LTC4215' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_LTC4245' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_LTC4261' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_LM95241' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_LM95245' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_MAX16065' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_MAX1668' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_MAX6639' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_MAX6642' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_MAX6650' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_SHT21' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_SMM665' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_DME1737' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_EMC1403' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_EMC2103' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_EMC6W201' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_SMSC47M192' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_ADS1015' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_ADS7828' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_AMC6821' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_THMC50' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_TMP102' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_TMP401' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_TMP421' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_W83791D' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_W83792D' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_W83793' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_W83795' n ${lxcfg}
  change_lxcfg 'CONFIG_SENSORS_W83L786NG' n ${lxcfg}

  #change_lxcfg 'CONFIG_SOFT_WATCHDOG' n ${lxcfg}

  echo "RTC"

  change_lxcfg 'CONFIG_RTC_DRV_DS1307' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_DS1374' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_DS1672' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_MAX6900' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_RS5C372' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_ISL1208' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_X1205' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_PCF8563' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_PCF8583' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_M41T80' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_BQ32K' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_S35390A' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_FM3130' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_RX8581' n ${lxcfg}
  change_lxcfg 'CONFIG_RTC_DRV_RX8025' n ${lxcfg}
fi


if $lxcfgfull ; then
  true

  echo "MEDIA"
  change_lxcfg 'CONFIG_MEDIA_SUPPORT' m ${lxcfg}

  change_lxcfg 'CONFIG_MEDIA_CAMERA_SUPPORT' y ${lxcfg}
  change_lxcfg 'CONFIG_MEDIA_ANALOG_TV_SUPPORT' y ${lxcfg}
  change_lxcfg 'CONFIG_MEDIA_DIGITAL_TV_SUPPORT' y ${lxcfg}
  change_lxcfg 'CONFIG_MEDIA_RADIO_SUPPORT' y ${lxcfg}
  change_lxcfg 'CONFIG_MEDIA_SDR_SUPPORT' y ${lxcfg}
  change_lxcfg 'CONFIG_MEDIA_RC_SUPPORT' y ${lxcfg}

  change_lxcfg 'CONFIG_MEDIA_USB_SUPPORT' y ${lxcfg}
#  change_lxcfg 'CONFIG_MEDIA_PCI_SUPPORT' y ${lxcfg}


  mxl5005s=m
  if [ -e include/qnap ]; then
    mxl5005s=n
  fi
  if [ -e arch/arm/mach-comcerto/include/mach/comcerto-2000/gpio.h ]; then
    if grep '#define GPIO_4' arch/arm/mach-comcerto/include/mach/comcerto-2000/gpio.h > /dev/null ; then
      mxl5005s=n
    fi
  fi

  change_lxcfg 'CONFIG_MEDIA_TUNER_MXL5005S' ${mxl5005s} ${lxcfg}

  change_lxcfg 'CONFIG_RC_DEVICES' y ${lxcfg}
  change_lxcfg 'CONFIG_DVB_USB_V2' m ${lxcfg}



  zl10039=m
  if [ -e include/qnap ]; then
    zl10039=n
  fi
  if [ -e arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h ]; then
    if grep '#define PLL0....0' arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h > /dev/null ; then
      zl10039=n
    fi
  fi

  change_lxcfg 'CONFIG_DVB_USB_CXUSB'  ${mxl5005s} ${lxcfg}
  change_lxcfg 'CONFIG_DVB_USB_DW2102' ${zl10039}  ${lxcfg}
  change_lxcfg 'CONFIG_DVB_USB_AF9015' ${mxl5005s} ${lxcfg}
  change_lxcfg 'CONFIG_DVB_USB_CE6230' ${mxl5005s} ${lxcfg}
  change_lxcfg 'CONFIG_DVB_USB_EC168'  ${mxl5005s} ${lxcfg}


  change_lxcfg 'CONFIG_DVB_ZL10039' ${zl10039} ${lxcfg}

  m88dc2800=m
  ##if [ -e arch/arm/configs/gfrg200_defconfig ]; then
  ##  m88dc2800=n
  ##fi
  #if [ -e arch/arm/mach-comcerto/include/mach/comcerto-2000/gpio.h ]; then
  #  if grep '#define GPIO_14' arch/arm/mach-comcerto/include/mach/comcerto-2000/gpio.h > /dev/null ; then
  #    m88dc2800=n
  #  fi
  #fi

  change_lxcfg 'CONFIG_DVB_M88DC2800' ${m88dc2800} ${lxcfg}
 
  change_lxcfg 'CONFIG_VIDEO_SAA7134_DVB' ${zl10039} ${lxcfg}

  cx23885=${m88dc2800}

  change_lxcfg 'CONFIG_VIDEO_CX23885' ${cx23885} ${lxcfg}
  change_lxcfg 'CONFIG_MEDIA_ALTERA_CI' ${cx23885} ${lxcfg}

else
  change_lxcfg 'CONFIG_MEDIA_SUPPORT' n ${lxcfg}
fi


if $lxcfgmidi ; then
  #echo "MMC"

  #echo "BT"

  echo "other"

  change_lxcfg 'CONFIG_BAYCOM_PAR' m ${lxcfg}
  change_lxcfg 'CONFIG_BAYCOM_EPP' m ${lxcfg}

  change_lxcfg 'CONFIG_CAN_GS_USB' m ${lxcfg}
  change_lxcfg 'CONFIG_CAN_KVASER_USB' m ${lxcfg}
  change_lxcfg 'CONFIG_CAN_PEAK_USB' m ${lxcfg}
  change_lxcfg 'CONFIG_CAN_8DEV_USB' m ${lxcfg}

  change_lxcfg 'CONFIG_NET_KEY' m ${lxcfg}
  # debian build enables it
  change_lxcfg 'CONFIG_NET_KEY_MIGRATE' y ${lxcfg}

  change_lxcfg 'CONFIG_NET_TEAM' m ${lxcfg}
  change_lxcfg 'CONFIG_NET_TEAM_MODE_BROADCAST' m ${lxcfg}
  change_lxcfg 'CONFIG_NET_TEAM_MODE_ROUNDROBIN' m ${lxcfg}
  change_lxcfg 'CONFIG_NET_TEAM_MODE_RANDOM' m ${lxcfg}
  change_lxcfg 'CONFIG_NET_TEAM_MODE_ACTIVEBACKUP' m ${lxcfg}
  change_lxcfg 'CONFIG_NET_TEAM_MODE_LOADBALANCE' m ${lxcfg}

  change_lxcfg 'CONFIG_VXLAN' m ${lxcfg}

  change_lxcfg 'CONFIG_ISCSI_TARGET' m ${lxcfg}

  change_lxcfg 'CONFIG_OPENVSWITCH' m ${lxcfg}
  change_lxcfg 'CONFIG_OPENVSWITCH_GRE' y ${lxcfg}
  change_lxcfg 'CONFIG_OPENVSWITCH_VXLAN' y ${lxcfg}

  change_lxcfg 'CONFIG_SCSI_LOWLEVEL' y ${lxcfg}

  change_lxcfg 'CONFIG_MDIO' m ${lxcfg}

  # disabled, broken in some kernels
  change_lxcfg 'CONFIG_SFC' n ${lxcfg}

fi


if $lxcfgfull ; then
  true

  change_lxcfg 'CONFIG_DISPLAY_SUPPORT' m ${lxcfg}
  change_lxcfg 'CONFIG_SOUND' m ${lxcfg}

else
  change_lxcfg 'CONFIG_DISPLAY_SUPPORT' n ${lxcfg}
  change_lxcfg 'CONFIG_SOUND' n ${lxcfg}
fi


if $lxcfgmidi ; then
  #change_lxcfg 'CONFIG_IR_TTUSBIR' m ${lxcfg}

  change_lxcfg 'CONFIG_MFD_RTSX_USB' m ${lxcfg}

  change_lxcfg 'CONFIG_MEMSTICK_REALTEK_USB' m ${lxcfg}
fi


if $lxcfgfull ; then
  true

  change_lxcfg 'CONFIG_SND_BCD2000' m ${lxcfg}

  # disable some PCI AC97 cards
  change_lxcfg 'CONFIG_SND_ALS4000' n ${lxcfg}
  change_lxcfg 'CONFIG_SND_CS5530' n ${lxcfg}
  change_lxcfg 'CONFIG_SND_SIS7019' n ${lxcfg}

  change_lxcfg 'CONFIG_SND_OPL3_LIB' n ${lxcfg}
  change_lxcfg 'CONFIG_SND_OPL4_LIB' n ${lxcfg}

  # disable some PCI OPL3 cards

fi

if $lxcfgextra ; then
  true

  change_lxcfg 'CONFIG_SND_OPL3_LIB' m ${lxcfg}
fi


if $lxcfgmidi ; then
  change_lxcfg 'CONFIG_NLS_MAC_ROMAN' m ${lxcfg}
  change_lxcfg 'CONFIG_NLS_MAC_CELTIC' m ${lxcfg}
  change_lxcfg 'CONFIG_NLS_MAC_CENTEURO' m ${lxcfg}
  change_lxcfg 'CONFIG_NLS_MAC_CROATIAN' m ${lxcfg}
  change_lxcfg 'CONFIG_NLS_MAC_CYRILLIC' m ${lxcfg}
  change_lxcfg 'CONFIG_NLS_MAC_GAELIC' m ${lxcfg}
  change_lxcfg 'CONFIG_NLS_MAC_GREEK' m ${lxcfg}
  change_lxcfg 'CONFIG_NLS_MAC_ICELAND' m ${lxcfg}
  change_lxcfg 'CONFIG_NLS_MAC_INUIT' m ${lxcfg}
  change_lxcfg 'CONFIG_NLS_MAC_ROMANIAN' m ${lxcfg}
  change_lxcfg 'CONFIG_NLS_MAC_TURKISH' m ${lxcfg}

  #change_lxcfg 'CONFIG_USB_HID' y ${lxcfg}
  #change_lxcfg 'CONFIG_USB_DEBUG' y ${lxcfg}

  change_lxcfg 'CONFIG_USB_PRINTER' m ${lxcfg}
fi


if $lxcfgfull ; then
  true

  change_lxcfg 'CONFIG_VIDEO_EM28XX_V4L2' m ${lxcfg}
  #change_lxcfg 'CONFIG_VIDEO_EM28XX_RC' m ${lxcfg}

  change_lxcfg 'CONFIG_USB_GSPCA_DTCS033' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_GSPCA_JL2005BCD' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_GSPCA_STK1135' m ${lxcfg}

fi


if $lxcfgmidi ; then
  # change_lxcfg 'CONFIG_USB_PWC_DEBUG is not set

  change_lxcfg 'CONFIG_USB_EHSET_TEST_FIXTURE' m ${lxcfg}


  change_lxcfg 'CONFIG_USB_RTL8152' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_NET_CDC_MBIM' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_NET_SR9700' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_NET_SR9800' m ${lxcfg}

  if [ ! -e arch/arm/configs/alpine_defconfig ]; then
    change_lxcfg 'CONFIG_USB_NET_QMI_WWAN' m ${lxcfg}
  fi

  change_lxcfg 'CONFIG_USB_SERIAL_SIMPLE' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_SERIAL_F81232' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_SERIAL_METRO' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_SERIAL_MXUPORT' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_SERIAL_XSENS_MT' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_SERIAL_WISHBONE' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_SERIAL_ZTE' m ${lxcfg}
  change_lxcfg 'CONFIG_USB_SERIAL_QT2' m ${lxcfg}
fi



if grep 'CONFIG_COMCERTO_' ${lxcfg} > /dev/null ; then
  change_lxcfg 'CONFIG_COMCERTO_AHCI_PROF' n ${lxcfg}
  change_lxcfg 'CONFIG_COMCERTO_SPLICE_PROF' n ${lxcfg}
  change_lxcfg 'CONFIG_COMCERTO_MDMA_PROF' n ${lxcfg}
fi

if [ -e arch/arm/configs/alpine_defconfig ]; then
  change_lxcfg 'CONFIG_SYNO_NOTIFY' n ${lxcfg}
fi

change_lxcfg 'CONFIG_KEXEC' y ${lxcfg}

change_lxcfg 'CONFIG_NETCONSOLE' m ${lxcfg}
change_lxcfg 'CONFIG_NETCONSOLE_DYNAMIC' y ${lxcfg}

change_lxcfg 'CONFIG_NLS' y ${lxcfg}
change_lxcfg 'CONFIG_NLS_CODEPAGE_437' y ${lxcfg}
change_lxcfg 'CONFIG_NLS_ISO8859_1' y ${lxcfg}
change_lxcfg 'CONFIG_NLS_ISO8859_15' y ${lxcfg}
change_lxcfg 'CONFIG_NLS_UTF8' y ${lxcfg}

change_lxcfg 'CONFIG_SCSI_TGT' m ${lxcfg}
change_lxcfg 'CONFIG_BLK_DEV_SR_VENDOR' y ${lxcfg}
change_lxcfg 'CONFIG_ATA_SFF' y ${lxcfg}
change_lxcfg 'CONFIG_TARGET_CORE' m ${lxcfg}

change_lxcfg 'CONFIG_BONDING' m ${lxcfg}
change_lxcfg 'CONFIG_PPP' m ${lxcfg}

change_lxcfg 'CONFIG_SSB' y ${lxcfg}


# broken on some kernels/machs
change_lxcfg 'CONFIG_PM_RUNTIME' n ${lxcfg}
change_lxcfg 'CONFIG_PM_DEBUG' n ${lxcfg}
change_lxcfg 'CONFIG_PM_ADVANCED_DEBUG' n ${lxcfg}
change_lxcfg 'CONFIG_PM_TEST_SUSPEND' n ${lxcfg}

change_lxcfg 'CONFIG_USB_SUSPEND' n ${lxcfg}


# allow USB boot without modules
change_lxcfg 'CONFIG_BLOCK' y ${lxcfg}
change_lxcfg 'CONFIG_SCSI_MOD' y ${lxcfg}
change_lxcfg 'CONFIG_SCSI' y ${lxcfg}
change_lxcfg 'CONFIG_BLK_DEV_SD' y ${lxcfg}

change_lxcfg 'CONFIG_CHR_DEV_SG' y ${lxcfg}

change_lxcfg 'CONFIG_USB_STORAGE' y ${lxcfg}

if grep 'CONFIG_USB_EHCI_HCD_ORION=' ${lxcfg} > /dev/null ; then
  change_lxcfg 'CONFIG_USB_ARCH_HAS_EHCI' y ${lxcfg}
  change_lxcfg 'CONFIG_USB_EHCI_HCD' y ${lxcfg}
  change_lxcfg 'CONFIG_USB_EHCI_HCD_ORION' y ${lxcfg}
fi

if grep 'CONFIG_USB_EHCI_HCD_PLATFORM=' ${lxcfg} > /dev/null ; then
  change_lxcfg 'CONFIG_USB_ARCH_HAS_EHCI' y ${lxcfg}
  change_lxcfg 'CONFIG_USB_EHCI_HCD' y ${lxcfg}
  change_lxcfg 'CONFIG_USB_EHCI_HCD_PLATFORM' y ${lxcfg}
fi

if grep 'CONFIG_USB_XHCI_PLATFORM=' ${lxcfg} > /dev/null ; then
  change_lxcfg 'CONFIG_USB_ARCH_HAS_XHCI' y ${lxcfg}
  change_lxcfg 'CONFIG_USB_XHCI_HCD' y ${lxcfg}
  change_lxcfg 'CONFIG_USB_XHCI_PLATFORM' y ${lxcfg}
fi


if grep 'CONFIG_COMCERTO_SATA=' ${lxcfg} > /dev/null ; then
  change_lxcfg 'CONFIG_COMCERTO_SATA' y ${lxcfg}

  change_lxcfg 'CONFIG_SATA_AHCI_PLATFORM' y ${lxcfg}
fi

if grep 'CONFIG_SATA_AHCI_PLATFORM=' ${lxcfg} > /dev/null ; then
  change_lxcfg 'CONFIG_ATA' y ${lxcfg}
  change_lxcfg 'CONFIG_SATA_PMP' y ${lxcfg}
  change_lxcfg 'CONFIG_SATA_AHCI' y ${lxcfg}
  change_lxcfg 'CONFIG_SATA_AHCI_PLATFORM' y ${lxcfg}
fi


# for systemd
change_lxcfg 'CONFIG_FHANDLE' y ${lxcfg}
change_lxcfg 'CONFIG_CGROUPS' y ${lxcfg}

change_lxcfg 'CONFIG_NAMESPACES' y ${lxcfg}
change_lxcfg 'CONFIG_UTS_NS' y ${lxcfg}
change_lxcfg 'CONFIG_IPC_NS' y ${lxcfg}
change_lxcfg 'CONFIG_USER_NS' y ${lxcfg}
change_lxcfg 'CONFIG_PID_NS' y ${lxcfg}
change_lxcfg 'CONFIG_NET_NS' y ${lxcfg}

change_lxcfg 'CONFIG_EPOLL' y ${lxcfg}
change_lxcfg 'CONFIG_SIGNALFD' y ${lxcfg}
change_lxcfg 'CONFIG_TIMERFD' y ${lxcfg}

change_lxcfg 'CONFIG_BLK_DEV_BSG' y ${lxcfg}
change_lxcfg 'CONFIG_BLK_DEV_BSGLIB' y ${lxcfg}

change_lxcfg 'CONFIG_NET' y ${lxcfg}

change_lxcfg 'CONFIG_DEVTMPFS' y ${lxcfg}
# change_lxcfg 'CONFIG_DEVTMPFS_MOUNT' n ${lxcfg}

change_lxcfg 'CONFIG_DEVPTS_MULTIPLE_INSTANCES' y ${lxcfg}

change_lxcfg 'CONFIG_INOTIFY_USER' y ${lxcfg}

change_lxcfg 'CONFIG_PROC_FS' y ${lxcfg}
change_lxcfg 'CONFIG_SYSFS' y ${lxcfg}

change_lxcfg 'CONFIG_SYSFS_DEPRECATED' n ${lxcfg}
change_lxcfg 'CONFIG_SYSFS_DEPRECATED_V2' n ${lxcfg}

sed -i s/'CONFIG_UEVENT_HELPER_PATH=.*'/'CONFIG_UEVENT_HELPER_PATH=""'/g ${lxcfg}


# debugging/tracing
change_lxcfg 'CONFIG_ENABLE_WARN_DEPRECATED' y ${lxcfg}
change_lxcfg 'CONFIG_ENABLE_MUST_CHECK' y ${lxcfg}
change_lxcfg 'CONFIG_FRAME_WARN' 2048 ${lxcfg}

change_lxcfg 'CONFIG_STRIP_ASM_SYMS' n ${lxcfg}
change_lxcfg 'CONFIG_UNUSED_SYMBOLS' y ${lxcfg}

change_lxcfg 'CONFIG_EVENT_POWER_TRACING_DEPRECATED' y ${lxcfg}

change_lxcfg 'CONFIG_FTRACE' y ${lxcfg}


if [ -e debian/config ]; then
  echo "Creating debian defines..."

  if false; then
    cat <<EOFDEBDEA | tee debian/config/${NAS_ARCH}/defines
[base]
flavours:
kernel-arch: arm

[image]
suggests: fdutils
configs:
 armel/config
 armhf/config
EOFDEBDEA
  fi

  if [ "x${NAS_MODEL}" = "x${NAS_MODEL_2}" ]; then
    if ! grep ${NAS_MODEL} debian/config/${NAS_ARCH}/defines > /dev/null ; then
      sed -i s/'flavours:'/'flavours:\n '${NAS_MODEL}/g debian/config/${NAS_ARCH}/defines
    fi
  else
    cp -p debian/config/${NAS_ARCH}/config.${NAS_MODEL} debian/config/${NAS_ARCH}/config.${NAS_MODEL_2}

    change_lxcfg 'CONFIG_4BAY' n debian/config/${NAS_ARCH}/config.${NAS_MODEL_2}

    if ! grep ${NAS_MODEL} debian/config/${NAS_ARCH}/defines > /dev/null ; then
      sed -i s/'flavours:'/'flavours:\n '${NAS_MODEL_2}'\n '${NAS_MODEL}/g debian/config/${NAS_ARCH}/defines
    fi
  fi


  if ! grep ${NAS_MODEL_2}_build debian/config/${NAS_ARCH}/defines > /dev/null ; then
    cat <<EOFDEBDES | tee -a debian/config/${NAS_ARCH}/defines

[${NAS_MODEL_2}_build]
image-file: arch/arm/boot/uImage

[${NAS_MODEL_2}_description]
hardware: ${NAS_VENDOR_SHORT} ${NAS_NAME_SHORT_2}
hardware-long: ${NAS_VENDOR} ${NAS_NAME_2} systems

[${NAS_MODEL_2}_image]
recommends: uboot-mkimage
EOFDEBDES
  fi


  if ! grep ${NAS_MODEL}_build debian/config/${NAS_ARCH}/defines > /dev/null ; then
    cat <<EOFDEBDEF | tee -a debian/config/${NAS_ARCH}/defines

[${NAS_MODEL}_build]
image-file: arch/arm/boot/uImage

[${NAS_MODEL}_description]
hardware: ${NAS_VENDOR_SHORT} ${NAS_NAME_SHORT}
hardware-long: ${NAS_VENDOR} ${NAS_NAME} systems

[${NAS_MODEL}_image]
recommends: uboot-mkimage
EOFDEBDEF
  fi

# defines/config
fi

cd ..

#EOF
