#!/bin/sh
. ./combine-env.sh

lxsocpa=1_0_0_00_0
if [ $lxsocva = 3.2.54 ]; then
  lxsocpa=3_2_5_00_2
elif [ $lxsocva = 3.2.26 ]; then
  lxsocpa=3_2_3_01_2
fi

pkeep=\
'201-extra_optimization|'\
'920-unable_to_open_console|'\
'921-use_preinit_as_init|'\
'950-vm_exports'

lxbuild=linux
if [ "x$1" != "x" ]; then
  lxbuild=$1
else
  if [ ! -e linux -a ! -e linux-${lxsocka} ]; then
    mkdir -p archives
    cd archives

    if [ ! -e linux -a ! -e linux-${lxsocka}.tar.xz ]; then
      echo "Downloading linux-${lxsocka}..."
      wget -N ${lxsocua}/linux-${lxsocka}.tar.xz
    fi

    cd ..

    if [ ! -e config ]; then
      echo "Downloading config linux-${lxsocka}..."
      wget -N ${lxsocua}/config
    fi

    echo "Extracting linux-${lxsocka}..."
    tar xJf archives/linux-${lxsocka}.tar.xz
    mv linux-${lxsocka} linux

    if [ ! -e linux/patches ]; then
      cd archives/
      wget -N http://seafile.servator.de/nas/common/mspd-kernel_linux_${lxsocpa}-patches.tar.gz
      cd ..

      if [ -e archives/mspd-kernel_linux_${lxsocpa}-patches.tar.gz ]; then
        mkdir linux/patches
        cd linux/patches
        tar xzf ../../archives/mspd-kernel_linux_${lxsocpa}-patches.tar.gz
        mv series series-c2k
        cd ..

        if [ -e arch/arm/configs/sequoia_defconfig ]; then
          sed -i /^generic.102-ehci_hcd_ignore_oc/d patches/series-c2k
        fi

        if [ -e arch/arm/configs/gfrg200_defconfig ]; then
          sed -i /^generic.102-ehci_hcd_ignore_oc/d patches/series-c2k
          sed -i /^generic.930-crashlog/d           patches/series-c2k
        fi

        cd ..
      fi
    fi

    if [ -e linux/patches/generic ]; then
      cd linux

      ps=patches/series
      if [ -e ${ps}-qnap ]; then
        ps=${ps}-qnap
      elif [ -e ${ps}-c2k ]; then
        ps=${ps}-c2k
      fi

      for f in `cat ${ps} | grep -E '^generic/' | grep -v -E ${pkeep} | sort -r` ; do
        echo $f ...
        patch -p1 -R < patches/$f || exit 1
      done

      cd .. 
    fi
  fi
fi

if [ ! -e ${lxbuild}/debian ]; then
  if [ -e ${lxbuild}/arch/arm/configs/alpine_defconfig -o \
       -e ${lxbuild}/arch/arm/configs/sequoia_defconfig -o \
       -e ${lxbuild}/arch/arm/mach-comcerto/board-optimus.c -o \
       -e ${lxbuild}/include/qnap ]; then
    bash patch-nas5xx.sh
  fi
fi

cd ${lxbuild}


if [ ! -e debian ]; then
  mkdir -p patches/platform


  if grep 'struct resource' include/linux/io.h > /dev/null ; then
    cp -p ../patches/linux_io_h_add_ioport_h.patch patches/platform/
    echo "platform/linux_io_h_add_ioport_h.patch" >> patches/series
  fi

  pset1="linux-3.2_jffs2-scan-num_zeros.patch
mspd-comcerto-2000-mac_addr_setup.patch
mspd-gpio-c2k-init.patch"

  if grep 'extern cpu1_hotplug' arch/arm/mach-comcerto/hotplug.c > /dev/null ; then
    pset1="${pset1}
mspd-hotplug-fixes.patch"
  fi

  if grep 'static int set_led_config' arch/arm/mach-comcerto/gpio.c > /dev/null ; then
    pset1="${pset1}
zyxel-nas5xx-gpio-led-fixes.patch"
  fi

  if grep 'HDD_SET_CTL_IOC_NUM' arch/arm/mach-comcerto/gpio.c > /dev/null ; then
    pset1="${pset1}
zyxel-nas5xx-gpio-mcu-fixes.patch"
  fi

  if grep 'copy_to_user(ppos,&pos,sizeof(loff_t));' fs/splice.c > /dev/null ; then
    if [ -e include/qnap ]; then
      # todo
      true
    else
      pset1="${pset1}
mspd-fs-splice-copy_to_user.patch"
    fi
  fi

  if grep 'CONFIG_4BAY' drivers/scsi/sd.c > /dev/null ; then
      pset1="${pset1}
zyxel-nas5xx-drive_bays_setup.patch"
  fi

  for p in $pset1 ; do
    cp -p ../patches/$p patches/platform/
    echo "platform/$p" >> patches/series
  done


  p=linux-3.2.54_cgroup-update.patch

    cp -p ../patches/$p patches/platform/
    echo "platform/$p" >> patches/series


  pset2="linux-3.2_cgroup_add_xattr.patch
linux-3.2_return_address.patch
linux-3.2_drivers-staging-rtl8712-ieee80211.patch
linux-3.2_rc.patch
linux-3.2_ubifs-no-date-time.patch
linux-3.2_af-packet.patch
linux-3.2_ath6kl-sdio.patch
linux-3.2_drivers-staging-rtl8712-ieee80211-part2.patch
linux-3.2_serial-8250.patch
linux-3.2_ncpfs.patch
linux-3.2_atm-iphase.patch
linux-3.2_dvb-frontends.patch
linux-3.2_cifs.patch
linux-3.2_blkdev.patch
linux-3.2_libsas.patch
linux-3.2_ipv6-txopt.patch
linux-3.2_nfs.patch
linux-3.2_scsi_netlink.patch
linux-3.2_drm.patch
linux-3.2_mmc-ioctl.patch"

  if grep 'defined(@val)' kernel/timeconst.pl > /dev/null ; then
      pset2="${pset2}
linux-3.2.26_kernel-timeconst.patch"
  fi

  if ! grep 'struct sk_buff;' include/linux/kobject.h > /dev/null ; then
      pset2="${pset2}
linux-3.2_kobject-skbuff.patch"
  fi

  for p in $pset2 ; do
    cp -p ../patches/$p patches/platform/
    echo "platform/$p" >> patches/series
  done


  p=linux-3.2.54_gcc6.patch

    cp -p ../patches/$p patches/platform/
    echo "platform/$p" >> patches/series


  pset3="zyxel-nas5xx-ip6_tnl_4rd.patch
zyxel-nas5xx-pfe-fixes.patch
zyxel-nas5xx-eeprom-fixes.patch
zyxel-nas5xx-otg-fixes.patch
zyxel-nas5xx-vwd-fixes.patch
zyxel-nas5xx-udp-fixes.patch
zyxel-nas5xx-net-core-fixes.patch
zyxel-nas5xx-netfilter-fixes.patch
zyxel-nas5xx-xhci-c2k-fixes.patch
zyxel-nas5xx-mach-fixes.patch"

  if [ -e drivers/epn1802-ocf/m86xxx.c ]; then
    pset3="${pset3}
zyxel-nas5xx-ocf-fixes.patch"
  fi

  if grep 'The xhci platform device has set up IRQs' drivers/usb/host/xhci.c > /dev/null ; then
pset3="${pset3}
zyxel-nas5xx-xhci-fixes.patch"
  fi

  if grep '#if 0' drivers/tty/tty_ldisc.c > /dev/null ; then
pset3="${pset3}
zyxel-nas5xx-tty-fixes.patch"
  fi

  if grep 'static const struct platform_device comcerto_otp_device' arch/arm/mach-comcerto/comcerto-2000.c > /dev/null ; then
    pset3="${pset3}
zyxel-nas5xx-mach-otp-fixes.patch"
  fi

  if ! grep '#if 1' arch/arm/mach-comcerto/pcie-c2000.c > /dev/null ; then
    pset3="${pset3}
zyxel-nas5xx-mach-pcie-fixes.patch"
  fi

  if grep 'static spinlock_t reset_lock' arch/arm/mach-comcerto/reset.c > /dev/null ; then
pset3="${pset3}
zyxel-nas5xx-mach-reset-fixes.patch"
  fi

  if [ -e arch/arm/configs/sequoia_defconfig ]; then
    pset3="zyxel-nas5xx-eeprom-fixes.patch
zyxel-nas5xx-udp-fixes.patch
zyxel-nas5xx-xhci-c2k-fixes.patch
zyxel-nas5xx-mach-fixes.patch"
  fi

  if grep 'struct resource \*res;' drivers/mtd/devices/m25p80.c > /dev/null ; then
    pset3="${pset3}
zyxel-nas5xx-m25p80-fixes.patch"
  fi

  if grep CONFIG_OCF_DM_CRYPT drivers/md/dm-crypt.c > /dev/null ; then
    pset3="${pset3}
zyxel-nas5xx-md-dm-crypt-fixes.patch"
  fi

  for p in $pset3 ; do
    cp -p ../patches/$p patches/platform/
    echo "platform/$p" >> patches/series
  done


  p=linux-combine-post
  echo "Patching ${lxbuild}..."

  #quilt push -a
  quilt push -a 2>&1 1>../${p}.patch.log
  r=$?

  if [ $r != 0 ]; then
    cat ../${p}.patch.log | grep 'rejects in file' | cut -d - -f 3- | cut -d " " -f 5
    echo Failed $r
    exit $r
  fi

fi


#exit

  dfiles="Makefile
arch/arm/mach-comcerto/include/mach/board-*.h
arch/arm/mach-comcerto/include/mach/comcerto-2000.h
arch/arm/mach-comcerto/include/mach/comcerto-common.h
arch/arm/mach-comcerto/include/mach/ecc.h
arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h
arch/arm/mach-comcerto/include/mach/comcerto-2000/gpio.h
arch/arm/mach-comcerto/include/mach/comcerto-2000/irqs.h
arch/arm/mach-comcerto/board-*.c
arch/arm/mach-comcerto/clock.c
arch/arm/mach-comcerto/comcerto-2000.c
arch/arm/mach-comcerto/gpio.c
drivers/ata/libahci.c
drivers/char/random.c
drivers/epn1802-ocf/Makefile
drivers/pfe_ctrl/Makefile
drivers/pfe_ctrl/pfe_eth.h
drivers/spi2/busses/comcerto_spi.c
drivers/usb/core/hcd-pci.c
drivers/usb/core/hub.c
drivers/usb/host/xhci.c
include/linux/syno.h
net/ipv6/Makefile
net/ipv6/output_core.c"

  d=`pwd`
  d=`basename ${d}`
  cd ..

  if [ -e a -o -e b ]; then
    echo "a or b exists! can not create custom patch."
    exit 1
  fi

  ln -s ${d} b
  cd - > /dev/null

  for f in $dfiles ; do
    if [ -e $f ]; then
      d=`dirname $f`
      mkdir -p ../a/${d}
      cp -p $f ../a/${d}/
    fi
  done

  if grep -E 'arm-marvell-linux-gnueabi|powerpc-none-linux-gnuspe' Makefile > /dev/null ; then
    sed -i s/'CROSS_COMPILE.*?=.*'/'CROSS_COMPILE ?= $(CONFIG_CROSS_COMPILE:"%"=%)'/g Makefile
    sed -i s/'ARCH.*?=.*powerpc'/'ARCH ?= $(SUBARCH)'/g Makefile
  fi

  if ! grep 'sound/ firmware/' Makefile > /dev/null ; then
    sed -i 's|drivers-y\t:= drivers/ sound/|drivers-y\t:= drivers/ sound/ firmware/|g' Makefile

    sed -i 's|-include $(srctree)/$(obj)/Makefile|include $(srctree)/$(obj)/Makefile|g' scripts/Makefile.fwinst
  fi

  if grep '.h $(srctree)/include/generated/' Makefile > /dev/null ; then
    sed -i 's|.h $(srctree)/include/generated/|.h include/generated/|g' Makefile
  fi

  if [ -e arch/arm/mach-comcerto/include/mach/ecc.h ]; then
    if grep -E '^#define ECC_UNCORR_ERR_HAMM.*0x4' arch/arm/mach-comcerto/include/mach/ecc.h > /dev/null ; then
      if grep -E '^#define ECC_UNCORR_ERR_HAMM.*(1 << 2)' arch/arm/mach-comcerto/include/mach/ecc.h > /dev/null ; then
        sed -i '/^#define ECC_UNCORR_ERR_HAMM.*0x4/d' arch/arm/mach-comcerto/include/mach/ecc.h
      fi
    fi
  fi

  if [ -e arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h -a -e arch/arm/mach-comcerto/clock.c ]; then
    #sed -i s/'define PLL'/'define C2K_CLK_PLL'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h
    #sed -i s/'define C2K_CLK_PLL_'/'define PLL_'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h

    sed -i s/'define PLL0\t'/'define C2K_CLK_PLL0\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h
    sed -i s/'define PLL1\t'/'define C2K_CLK_PLL1\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h
    sed -i s/'define PLL2\t'/'define C2K_CLK_PLL2\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h
    sed -i s/'define PLL3\t'/'define C2K_CLK_PLL3\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h

    sed -i s/'case PLL0:'/'case C2K_CLK_PLL0:'/g arch/arm/mach-comcerto/clock.c
    sed -i s/'case PLL1:'/'case C2K_CLK_PLL1:'/g arch/arm/mach-comcerto/clock.c
    sed -i s/'case PLL2:'/'case C2K_CLK_PLL2:'/g arch/arm/mach-comcerto/clock.c
    sed -i s/'case PLL3:'/'case C2K_CLK_PLL3:'/g arch/arm/mach-comcerto/clock.c

    sed -i s/' PLL0)'/' C2K_CLK_PLL0)'/g arch/arm/mach-comcerto/clock.c
    sed -i s/' PLL1)'/' C2K_CLK_PLL1)'/g arch/arm/mach-comcerto/clock.c
    sed -i s/' PLL2)'/' C2K_CLK_PLL2)'/g arch/arm/mach-comcerto/clock.c
    sed -i s/' PLL3)'/' C2K_CLK_PLL3)'/g arch/arm/mach-comcerto/clock.c

    sed -i s/'(PLL0)'/'(C2K_CLK_PLL0)'/g arch/arm/mach-comcerto/clock.c
    sed -i s/'(PLL1)'/'(C2K_CLK_PLL1)'/g arch/arm/mach-comcerto/clock.c
    sed -i s/'(PLL2)'/'(C2K_CLK_PLL2)'/g arch/arm/mach-comcerto/clock.c
    sed -i s/'(PLL3)'/'(C2K_CLK_PLL3)'/g arch/arm/mach-comcerto/clock.c

    sed -i s/'define PLL_VSEL\t'/'define C2K_CLK_PLL_VSEL\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h
    sed -i s/'define PLL_LOCK_EN\t'/'define C2K_CLK_PLL_LOCK_EN\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h
    sed -i s/'define PLL_BYPASS\t'/'define C2K_CLK_PLL_BYPASS\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h
    sed -i s/'define PLL_RESET\t'/'define C2K_CLK_PLL_RESET\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h

    sed -i s/'define PLL_LOCK\t'/'define C2K_CLK_PLL_LOCK\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h

    sed -i s/'define SCPRE'/'define C2K_CLK_SCPRE'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h
    sed -i s/'define SCALL'/'define C2K_CLK_SCALL'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h
    sed -i s/'define ISO_EN'/'define C2K_CLK_ISO_EN'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/clk-rst.h
  fi

  if grep 'int readFile(struct file \*fp,int \*buf,int readlen)' arch/arm/mach-comcerto/gpio.c > /dev/null ; then
    sed -i s/'readFile(struct file \*fp,int \*buf'/'readFile(struct file *fp,char *buf'/g arch/arm/mach-comcerto/gpio.c
  fi

  if grep 'int set_buzzer(unsigned long bz_data)' arch/arm/mach-comcerto/gpio.c > /dev/null ; then
    sed -i s/'int set_buzzer'/'void set_buzzer'/g arch/arm/mach-comcerto/gpio.c
  fi

  if grep 'static int gpio_ioctl' arch/arm/mach-comcerto/gpio.c > /dev/null ; then
    sed -i s/'static int gpio_ioctl'/'static long gpio_ioctl'/g arch/arm/mach-comcerto/gpio.c
  fi

  if grep 'define GPIO_' arch/arm/mach-comcerto/include/mach/comcerto-2000/gpio.h > /dev/null ; then
    sed -i s/'define GPIO_0\t'/'define C2K_GPIO_0\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/gpio.h
    sed -i s/'define GPIO_1\t'/'define C2K_GPIO_1\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/gpio.h
    sed -i s/'define GPIO_2\t'/'define C2K_GPIO_2\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/gpio.h
    sed -i s/'define GPIO_6\t'/'define C2K_GPIO_6\t'/g arch/arm/mach-comcerto/include/mach/comcerto-2000/gpio.h

    for g in `seq 3 5` `seq 7 29`; do
      for f in arch/arm/mach-comcerto/include/mach/board-*.h ; do
        sed -i s/'GPIO_'$g/'C2K_GPIO_'$g/g $f
      done

      sed -i s/'GPIO_'$g/'C2K_GPIO_'$g/g arch/arm/mach-comcerto/include/mach/comcerto-2000/gpio.h
    done

    for f in arch/arm/mach-comcerto/include/mach/board-*.h ; do
      sed -i s/'GPIO_0 '/'C2K_GPIO_0 '/g $f
      sed -i s/' GPIO_0'/' C2K_GPIO_0'/g $f

      sed -i s/'GPIO_1 '/'C2K_GPIO_1 '/g $f
      sed -i s/' GPIO_1'/' C2K_GPIO_1'/g $f

      sed -i s/'GPIO_2 '/'C2K_GPIO_2 '/g $f
      sed -i s/' GPIO_2'/' C2K_GPIO_2'/g $f

      sed -i s/'GPIO_6'/'C2K_GPIO_6'/g $f
    done
  fi

  for n in UART SPI I2C ; do
    if grep 'define IRQ_'${n} arch/arm/mach-comcerto/include/mach/comcerto-2000/irqs.h > /dev/null ; then
      sed -i s/'define IRQ_'${n}/'define C2K_IRQ_'${n}/g arch/arm/mach-comcerto/include/mach/comcerto-2000/irqs.h

      for f in arch/arm/mach-comcerto/board-*.c arch/arm/mach-comcerto/comcerto-2000.c drivers/spi2/busses/comcerto_spi.c ; do
        sed -i s/' IRQ_'${n}/' C2K_IRQ_'${n}/g $f
      done
    fi
  done

  sed -i 's|-I ../../crypto/ocf|-I$(src)/../../crypto/ocf|g' drivers/epn1802-ocf/Makefile
  sed -i 's|-include $(src)/$(PFE_DIR)/c2000/version.h|-include $(PWD)/$(src)/$(PFE_DIR)/c2000/version.h|g' drivers/pfe_ctrl/Makefile
  sed -i 's|-T$(src)/control_link.lds|-T$(PWD)/$(src)/control_link.lds|g' drivers/pfe_ctrl/Makefile

  sed -i 's|cap.nr_ports for < AHCI 1.3 \*/|cap.nr_ports */|g' drivers/ata/libahci.c
  sed -i 's|(!port_map && vers < 0x10300)|(!port_map)|g' drivers/ata/libahci.c

  if ! grep 'mix_pool_bytes(struct entropy_store \*r, const void \*in, int bytes)' drivers/char/random.c > /dev/null ; then
    sed -i 's|mix_pool_bytes(\&input_pool, buf, wordcount\*4);|mix_pool_bytes(\&input_pool, buf, wordcount*4, NULL);|g' drivers/char/random.c
  fi

  if [ -e net/ipv6/output_core.c ]; then
    if ! grep output_core net/ipv6/Makefile > /dev/null ; then
      echo 'obj-$(CONFIG_INET) += output_core.o' >> net/ipv6/Makefile
    fi
  fi

  if grep -E '^header-y \+= xt_layer7.h' include/linux/netfilter/Kbuild > /dev/null ; then
    if [ ! -e include/linux/netfilter/xt_layer7.h ]; then
      sed -i s/'^header-y += xt_layer7.h'/''/g include/linux/netfilter/Kbuild
    fi
  fi

  # disable "Special reset" to allow USB boot
  if grep MY_ABC_HERE drivers/usb/core/hub.c > /dev/null ; then
    sed -i 's|^#define MY_ABC_HERE|//undefine MY_ABC_HERE|g' drivers/usb/core/hcd-pci.c
    sed -i 's|MY_ABC_HERE|MY_XHC_HERE|g' drivers/usb/core/hcd-pci.c
    sed -i 's|^#define MY_ABC_HERE|//undefine MY_ABC_HERE|g' drivers/usb/core/hub.c
    sed -i 's|MY_ABC_HERE|MY_XHC_HERE|g' drivers/usb/core/hub.c
    sed -i 's|^#define MY_ABC_HERE|//undefine MY_ABC_HERE|g' drivers/usb/host/xhci.c
    sed -i 's|MY_ABC_HERE|MY_XHC_HERE|g' drivers/usb/host/xhci.c
  fi
  
  if grep SYNO_USB3_LIGHTWEIGHT_SPECIAL_RESET drivers/usb/core/hub.c > /dev/null ; then
    sed -i 's|^#define SYNO_USB3_LIGHTWEIGHT_SPECIAL_RESET|/* undef SYNO_USB3_LIGHTWEIGHT_SPECIAL_RESET */|g' include/linux/syno.h
  fi

  if grep SYNO_USB3_RESET_WAIT drivers/usb/core/hub.c > /dev/null ; then
    sed -i 's|^#define SYNO_USB3_RESET_WAIT|/* undef SYNO_USB3_RESET_WAIT */|g' include/linux/syno.h
  fi

  if [ ! -e debian ]; then
    if [ -e arch/arm/configs/alpine_defconfig -o \
         -e arch/arm/configs/sequoia_defconfig -o \
         -e arch/arm/mach-comcerto/board-optimus.c -o \
         -e include/qnap ]; then
      cd ..
      bash convert-to-nas5xx.sh
      cd - > /dev/null
    fi
  fi

  rm -f patches/platform/mspd-c2k-post.patch
  for f in $dfiles ; do
    if [ -e $f ]; then
      d=`dirname $f`
      cd ..
      diff -u a/${f} b/${f} >> b/patches/platform/mspd-c2k-post.patch
      cd - > /dev/null
    fi
  done

  cd ..
  rm -rf a
  rm -f  b
  cd - > /dev/null

  p=mspd-c2k-post
  patch -p1 -R < patches/platform/${p}.patch

  echo "platform/${p}.patch" >> patches/series

  echo "Patching ${lxbuild}..."

  #quilt push -a
  quilt push -a 2>&1 1>../${p}.patch.log
  r=$?

  if [ $r != 0 ]; then
    cat ../${p}.patch.log | grep 'rejects in file' | cut -d - -f 3- | cut -d " " -f 5
    echo Failed $r
    exit $r
  fi

cd ..


